CREATE TABLE IF NOT EXISTS `{P}admin_files` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `uid` int(10) unsigned NOT NULL,
  `name` varchar(32) NOT NULL,
  `content` text NOT NULL,
  `autor` varchar(32) NOT NULL,
  `flag_auto_admin` smallint(5) unsigned NOT NULL,
  `flag_auto_index` smallint(5) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}user_groups` (
  `id` smallint(6) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `perms` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}user_data` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `pass` varchar(32) NOT NULL,
  `email` varchar(80) NOT NULL,
  `rank` smallint(5) unsigned NOT NULL,
  `lastlogin` int(10) unsigned NOT NULL,
  `lastip` varchar(15) NOT NULL,
  `option_editor` smallint(6) NOT NULL,
  `option_wysiwyg` smallint(6) NOT NULL,
  `option_note` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}data_text_vars` (
  `name` varchar(20) NOT NULL,
  `panel` int(11) NOT NULL,
  `value` text NOT NULL
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}data_short_vars` (
  `name` varchar(20) NOT NULL,
  `panel` int(11) NOT NULL,
  `value` varchar(80) NOT NULL
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}data_options` (
  `name` varchar(32) NOT NULL,
  `caption` varchar(32) NOT NULL,
  `value` varchar(100) NOT NULL
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}content_templates` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `type` int(11) NOT NULL,
  `content` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}content_panels` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `layer` int(10) unsigned NOT NULL,
  `group` int(10) unsigned NOT NULL,
  `template` int(11) NOT NULL,
  `name` varchar(32) NOT NULL,
  `script` int(10) unsigned NOT NULL,
  `status` smallint(6) NOT NULL,
  `prio` smallint(6) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `layer` (`layer`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}content_menu` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `panel` int(10) unsigned NOT NULL,
  `layer` int(10) unsigned NOT NULL,
  `caption` varchar(30) NOT NULL,
  `link` varchar(60) NOT NULL,
  `target` smallint(5) unsigned NOT NULL,
  `parent` int(10) unsigned NOT NULL,
  `prio` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}admin_menu` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}admin_moduls` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `uid` int(10) unsigned NOT NULL,
  `menu` int(10) unsigned NOT NULL,
  `name` varchar(32) NOT NULL,
  `content` text NOT NULL,
  `autor` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}admin_scripts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `uid` int(10) unsigned NOT NULL,
  `name` varchar(32) NOT NULL,
  `content` text NOT NULL,
  `editor` text NOT NULL,
  `tables` varchar(200) NOT NULL,
  `autor` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}content_groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(20) NOT NULL,
  `replace` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE IF NOT EXISTS `{P}content_layer` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `parent` int(10) unsigned NOT NULL,
  `template` int(11) NOT NULL,
  `rank` smallint(5) unsigned NOT NULL,
  `status` smallint(5) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '11', '2', 'Content Verwaltung', '<script language="javascript" type="text/javascript">
  function dellayer( id ) {
    if( window.confirm( "Wollen sie diesen Layer einschließlich aller untergeordneten Layer und Panels unwiederbringlich löschen?" ))
	window.location.href = \'<?php echo MODUL_SELF ?>&dellayer=\'+id;
  }
</script><?php

  $layer_temptype = 0;
  $panel_temptype = 1;

  function rekcheck( $layer ) {
    global $prefix, $userdata, $db;
	
	$layer = $db->id_get( $prefix."content_layer", $layer );
	if( $layer[\'rank\'] > $userdata[\'rank\'] ) return false;
	else {
	  $delable = true;
	  $subs = $db->get( $prefix."content_layer", "parent = \'$layer[id]\'" );
	  foreach( $subs as $sub ) if( !rekcheck( $sub[\'id\'] )) $delable = false;
	  return $delable;
	}
  }
  
  function rekdel( $layer ) {
    global $prefix, $db;
    $scripts = $db->get_assoc( $prefix."content_scripts", 1, "tables" );
	
    $subs = $db->get( $prefix."content_layer", "parent = \'$layer\'" );
    foreach( $subs as $sub ) rekdel( $sub[\'id\'] );
	
    $panels = $db->get( $prefix."content_panels", "layer = \'$layer\'" );
    foreach( $panels as $pan ) 
      foreach( explode( ",", $scripts[$panel[\'script\']] ) as $table )
        if( !empty( $table ))
          $db->del( $prefix.trim( $table ), "panel = \'$pan[id]\'" );
	  
    $db->del( $prefix."content_panels", "layer = \'$layer\'" );
    $db->id_del( $prefix."content_layer", $layer );
  }
  
  function check_ref( $ref, $layid ) {
    global $prefix, $db;
    if( $ref == 0 ) return true;
    elseif( $ref == $layid ) return false;
    else {
      $res = $db->id_get( $prefix."content_layer", $ref );
      return check_ref( $res[\'parent\'], $layid );
    }
  }

// Layer löschen
  if( !empty( $_GET[\'dellayer\'] )) 
    if( $dlayer = $db->id_get( $prefix."content_layer", $_GET[\'dellayer\'] ))
	  if( rekcheck( $dlayer[\'id\'] )) rekdel( $dlayer[\'id\'] );
	  else msgbox( \'Fehler beim löschen des Layers: Sie besitzen nicht genügend Rechte um diesen Layer zu löschen!\', \'Fehler beim Löschen!\' );

// Layer bearbeiten
  if( !empty( $_GET[\'layer\'] ) && !empty( $_POST[\'name\'] ) && ( $_POST[\'rank\'] <= $userdata[\'rank\'] )) 
    if( check_ref( (int) $_POST[\'parent\'], (int) $_GET[layer] ) ) {
      $query = array( "status" => $_POST[\'status\'], "name" => $_POST[\'name\'], "template" => $_POST[\'template\'], "rank" => $_POST[\'rank\'], "parent" => $_POST[\'parent\'] );
      $db->update( $prefix."content_layer", $query, "id = \'$_GET[layer]\' AND rank <= \'$userdata[rank]\'" );
    } else msgbox( \'Sie haben eine ungültige Referenz angegeben!\', \'Fehler beim bearbeiten!\' );


// Layer laden
  if( !empty( $_GET[\'layer\'] )) {
    $panel = false;
    $layer = $db->id_get( $prefix."content_layer", $_GET[\'layer\'] );
  } elseif( !empty( $_GET[\'panel\'] )) {
    $panel = $db->id_get( $prefix."content_panels",  $_GET[\'panel\'] );
	$layer = $db->id_get( $prefix."content_layer", $panel[\'layer\'] );
  } else { 
    $panel = false;
    $layer = false;
  }
  
// Rechte prüfen  
  if( $layer[\'rank\'] > $userdata[\'rank\'] ) {
    msgbox( \'Sie haben auf diesen Layer keinen Zugriff\', \'Unberechtigter Zugriff\' );
    $db->id_update( $prefix."user_data", array( "sessid" => "" ), $userdata[\'id\'] );
    $db->close(); page_footer(); exit();
  }  
  
// Startseite Setzen
  if( isset( $_GET[\'default\'] ) && $layer ) set_short_var( "defpage" , 0, $layer[\'id\'] );
  
  if( $panel && isset( $_GET[\'content\'] )) {

  if( !strstr( $usergroup[\'perms\'], ".S$panel[script]." ) && $userdata[\'rank\'] != 9 )  {
    msgbox( \'Sie haben auf diesen Layer keinen Zugriff\', \'Unberechtigter Zugriff\' );
    $db->id_update( $prefix."user_data", array( "sessid" => "" ), $userdata[\'id\'] );
    $db->close(); page_footer(); exit();
  }  

  define( "EDITOR_SELF", MODUL_SELF."&content=1&panel=".$panel[\'id\'] );
  define( "LAYER_SELF", MODUL_SELF."&layer=".$layer[\'id\'] );

  if( $script = $db->id_get( $prefix."admin_scripts", $panel[\'script\'] )) {
    cbox_auf( "Panel bearbeiten: ".htmlspecialchars( $panel[\'name\'] ) ); 
    eval( " ?>$script[editor]<?php " );
    cbox_zu();
  } else msgbox( \'Script nicht gefunden!?!\' );

} else {
  
// Panel Löschen  
  if( !empty( $_GET[\'delpanel\'] )) {
    $del = $db->id_get( $prefix."content_panels", $_GET[\'delpanel\'] );
    if( $del[\'layer\'] == $layer[\'id\'] || ( !$layer && $del[\'layer\'] == 0 )) 
      if( $script = $db->id_get( $prefix."admin_scripts", $del[\'script\'] )) {
	    foreach( explode( ",", $script[\'tables\'] ) as $table )
	      if( !empty( $table ))
	        $db->del( $prefix.trim( $table ), "panel = \'$del[id]\'" );
	    $db->id_del( $prefix."content_panels", $del[\'id\'] );
      }
  }
  
// Panel bearbeiten + erstellen
  if( !empty( $_POST[\'pname\'] ) && !empty( $_POST[\'group\'] )) 
  if( $db->id_get( $prefix."content_groups", $_POST[\'group\'] ))  {
	$_POST[\'name\'] = $_POST[\'pname\'];
	$_POST[\'template\'] = $_POST[\'ptemplate\'];
	unset( $_POST[\'id\'] ); $_POST[\'layer\'] = $layer[\'id\'];
	
    if( $panel ) {
	  $db->update( $prefix."content_panels", $_POST, "id = \'$panel[id]\' AND layer = \'$layer[id]\'" );
	  $panel = $db->id_get( $prefix."content_panels", $panel[\'id\'] );
	} elseif( !empty( $_POST[\'script\'] )) {
	  $_POST[\'script\'] = (int) $_POST[\'script\'];
	  if( strstr( $usergroup[\'perms\'], ".S$_POST[script]." ) || $userdata[\'rank\'] == 9 ) 
		$db->insert( $prefix."content_panels", $_POST );
	} 
  }
  
// Parent laden
  if( !empty( $layer[\'parent\'] )) $parent = $db->id_get( $prefix."content_layer", $layer[\'parent\'] );

// Neuen Layer anlegen
  if( isset( $_GET[\'addlayer\'] )) {
    $parent = $db->id_get( $prefix."content_layer", $_GET[\'addlayer\'] );
	
	$layer = array();
	$layer[\'name\'] = "neuer Layer";
	$layer[\'parent\'] = $parent[\'id\'];
	$layer[\'rank\'] = $parent[\'rank\'];
	
	$db->insert( $prefix."content_layer", $layer );
	$layer[\'id\'] = $db->id();
  }

// Seite in zwei spalten teilen
  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr><td width="350" valign="top">\';
  
// Layerliste
  $spage = get_short_var( "defpage" , 0 );

  function layertree( $parent, $depth ) {
    global $userdata, $db, $prefix, $layer, $spage;
	
	$layers = $db->get( $prefix."content_layer", "parent = \'$parent\'" );
	foreach( $layers as $l) {
	  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr>\';
	  
	  echo str_repeat( \'<td width="20" height="20"><img src="images/icons/tree1.png" alt ="|" boder="0"></td>\', $depth );
	  echo \'<td width="20" height="20"><img src="images/icons/tree2.png" alt="-" boder="0"></td><td width="20" height="20"><img src="images/icons/\'; 
	  
	  if( $l[\'id\'] == $layer[\'id\'] ) 
	    if( $l[\'status\'] ) echo \'ia\';
		else echo \'a\';
	  elseif( $l[\'status\'] ) echo \'i\';
	  
	  echo \'layer.gif" alt ="l" boder="0"></td>\';
	  
	  if( $l[\'rank\'] > $userdata[\'rank\'] ) echo \'<td style="font-size: 10px">&nbsp; \'.htmlspecialchars( $l[\'name\'] );
	  else echo \'<td style="font-size: 10px">&nbsp; <a href="\'.MODUL_SELF.\'&layer=\'.$l[\'id\'].\'">\'.htmlspecialchars( $l[\'name\'] ).\'</a>\';
	  if( $l[\'id\'] == $spage ) echo \' (s)\'; echo \'<td></tr></table>\';
	  layertree( $l[\'id\'], $depth+1 );
    }
  }
  
  cbox_auf( \'Layerliste\' );
  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr>\';
  if( !$layer ) echo \'<td width="20" height="20"><img src="images/icons/alayer.gif" alt ="l" boder="0"></td>\';
  else echo \'<td width="20" height="20"><img src="images/icons/layer.gif" alt ="l" boder="0"></td>\';
  echo \'<td style="font-size: 10px">&nbsp; <a href="\'.MODUL_SELF.\'">IV Content Management System</a><td></tr></table>\';
  
  layertree( 0, 0 );
  
  cbox_zu();
  
  cbox_auf( \'Panelliste\' ); $c = 0;
  $captions = array( "name" => "Name" );
  $panels = $db->get( $prefix."content_panels", "layer = \'$layer[id]\'" );
  if( !count( $panels )) echo \'<p align="center">Keine Panels vorhanden.</p>\';
  else { 
  
    $liste = new liste( $captions );        
    $liste->addop( "[X]", MODUL_SELF."&layer=".$layer[\'id\']."&delpanel=", true, "Löschen" );
    $liste->addop( "[E]", MODUL_SELF."&panel=", false, "Panel bearbeiten" );
    $liste->addop( "[I]", MODUL_SELF."&content=1&panel=", false, "Inhalt bearbeiten" );
    $liste->write( $panels, "100%" );
  
  } cbox_zu();
  
// Zweite Spalte
  echo \'</td><td width="15">&nbsp;</td><td valign="top">\';
  
// Layereinstellung
  if( $layer ) {
    cbox_auf( \'Layer bearbeiten\' );  
    $form = new form( MODUL_SELF."&layer=".$layer[\'id\'] );
	
// Assioziatives Array mit allen Gruppen erzeugen
    $gps = $db->get_assoc( $prefix."user_groups", "id < \'$userdata[rank]\'", "name" );
    if( $userdata[\'rank\'] == 9 ) $gps[9] = "Systemadministrator"; ksort( $gps );
    $layers = $db->get_assoc( $prefix."content_layer", "id != \'$layer[id]\' AND parent != \'$layer[id]\'", "name" );
    $layers[0] = "IV CMS"; 

    $form->add( "name", "Name", $layer[\'name\'] ); 
    $form->add( "template", "Template", $layer[\'template\'], "select", array_merge( array( "Kein Template" ) , $db->get_assoc( $prefix."content_templates", "`type` = \'$layer_temptype\'", "name" ))); 
    $form->add( "rank", "Mindestgruppe", $layer[\'rank\'], "select", $gps ); 
    $form->add( "status", "Status", $layer[\'status\'], "select", array( "Aufrufbar", "Deaktiviert" ));
    $form->add( "parent", "Parent", $layer[\'parent\'], "select", $layers ); 

    $form->write( "Speichern", 25 );
    cbox_zu();
  }
  
  cbox_auf( \'Optionen\' );  
    echo \'<p align="center"><input type="button" value="Layer hinzufügen" onclick="window.location.href = \\\'\'.MODUL_SELF."&addlayer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
    if( $layer ) {
      echo \'<p align="center"><input type="button" value="Layer entfernen" onclick="dellayer( \'.$layer[\'id\'].\' );" style="width: 90%"></p>\';
      echo \'<p align="center"><input type="button" value="Als Startseite verwenden" onclick="window.location.href = \\\'\'.MODUL_SELF."&default=1&layer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
      echo \'<p align="center"><input type="button" value="Unterpunkte Ein/Ausblenden" onclick="window.location.href = \\\'\'.MODUL_SELF."&hide=1&layer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
    }
  cbox_zu();
  
  
  if( $panel ) {
    cbox_auf( "Panel bearbeiten" );
	$form = new form( MODUL_SELF."&panel=".$panel[\'id\'] );
	define( "BACKBUTTON", MODUL_SELF."&layer=".$layer[\'id\'] );
  } else {
    cbox_auf( "Panel erstellen" );
    $form = new form( MODUL_SELF."&layer=".$layer[\'id\'] );
  }
  
  $form->add( "pname", "Name", $panel[\'name\'] ); 
  $form->add( "group", "Panelgroup", $panel[\'group\'], "select", $db->get_assoc( $prefix."content_groups", 1, "name" )); 
  $form->add( "ptemplate", "Template", $panel[\'template\'], "select", array_merge( array( 0 => "Kein Template" ), $db->get_assoc( $prefix."content_templates", "`type` = \'$panel_temptype\'", "name" ))); 
  
  if( !$panel ) {
    foreach( $db->get_assoc( $prefix."admin_scripts", 1, "name" ) as $i => $n )
	if( strstr( $usergroup[\'perms\'], ".S$i." ) || $userdata[\'rank\'] == 9 ) $scripts[$i] = $n;
    $form->add( "script", "Script", 0, "select", $scripts );  
  } 
  
  $form->add( "status", "Status", $panel[\'status\'], "select", array( "Aktiv", "Versteckt" )); 
  $form->add( "prio", "Priorität", $panel[\'prio\'] ); 
  $form->write( "Speichern", 25 );

  cbox_zu();

  
// ende der seite
  echo \'</td></tr></table>\';

}

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '12', '3', 'Optionen', '<?php

  $layertype = 0;
  $othertype = 3;

  if( isset( $_POST ) && isset( $_GET[\'update\'] ))
    foreach( $_POST as $key => $wert )
      $db->query( "UPDATE ".$prefix."data_options SET value = \'$wert\' WHERE name = \'$key\'" );
	  
  if( !empty( $_POST[\'deftemplate\'] )) set_short_var( "deftemplate", 0, $_POST[\'deftemplate\'] );
  if( !empty( $_POST[\'errortemplate\'] )) set_short_var( "errortemplate", 0, $_POST[\'errortemplate\'] );
  if( !empty( $_POST[\'newsscript\'] )) set_short_var( "newsscript", 0, $_POST[\'newsscript\'] );
  
  cbox_auf( $mod[\'name\'] );
  $form = new form( MODUL_SELF."&update" );
  foreach( $db->get( $prefix."data_options" ) as $option )
  $form->add( $option[\'name\'], $option[\'caption\'], $option[\'value\'] );
  
  $form->hr();
  $form->add( "deftemplate", "Hauptdesign", get_short_var( "deftemplate", 0 ), "select", $db->get_assoc( $prefix."content_templates", "`type` = \'$layertype\'", "name" ));
  $form->add( "errortemplate", "Wartungsdesign", get_short_var( "errortemplate", 0 ), "select", $db->get_assoc( $prefix."content_templates", "`type` = \'$othertype\'", "name" ));
  $form->add( "newsscript", "News Script", get_short_var( "newsscript", 0 ), "select", $db->get_assoc( $prefix."admin_scripts", 1, "name" ));
  
  $form->write( "Speichern", 40 );
  cbox_zu();

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '13', '2', 'Templates', '<?php

if( empty( $_GET[\'edit\'])) {

// Einfügen oder Aktuallisieren von Templates
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."content_templates", array( "name" => $_POST[\'name\'], "type" => $_POST[\'type\'] ));
     else $db->id_update( $prefix."content_templates", array( "name" => $_POST[\'name\'], "type" => $_POST[\'type\'] ), $_GET[\'update\'] );

// TemplateTypen 
 $types = array( "Layer-Template", "Panel-Template", "News-Templates", "Sonstige Templates" );

// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Template erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."content_templates", $_GET[\'settings\'] );
   cbox_auf( \'Teplate bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Templatename\', $settings[\'name\'], \'text\' );
 $form->add( \'type\', \'Templatetype\', $settings[\'type\'], \'select\', $types );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste der Templates
 $captions = array( "id" => "ID", "name" => "Name" );
 foreach( $types as $key => $type ) {
   cbox_auf( $type );

   $templates = $db->get( $prefix."content_templates", "`type` = \'$key\'" );

   $liste = new liste( $captions );
   $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
   $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
   $liste->write( $templates, "100%" );

   cbox_zu();
 }

} else {

// Bearbeiten von Templateinhalt
 if( $edit_template = $db->get( $prefix."content_templates", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von Templateinhalt
     if( isset( $_POST[\'template_source\'] )) {
       $db->id_update( $prefix."content_templates", array( "content" => $_POST[\'template_source\'] ), $edit_template[\'id\'] );
       $edit_template[\'content\'] = stripslashes( $_POST[\'template_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Template bearbeiten: ".$edit_template[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_template[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'template_source\', $edit_template[\'content\'], $userdata[\'option_editor\'], "html" );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim öffnen" );

}

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '14', '3', 'Wartungsmodus', '<?php

  if( isset( $_POST[\'wartung\'] )) {
    set_short_var( "wartung", 0, $_POST[\'wartung\'] );
    set_text_var( "wreason", 0, $_POST[\'reason\'] );
  }

  cbox_auf( $mod[\'name\'] );
  $form = new form( MODUL_SELF );
  $form->add( "wartung", "Wartungsmodus", get_short_var( "wartung", 0 ), "select", array( "Ausgeschaltet", "Eingeschaltet"  )); 
  $form->add( "reason", "Begründung", get_text_var( "wreason", 0 ), "textarea", 10 );
  $form->write( "Speichern" );
  cbox_zu();

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '15', '1', 'Userdaten Ändern', '<?php

  if( !empty( $_POST[\'oldpass\'] ))
    if( $userdata[\'pass\'] == md5( $_POST[\'oldpass\'] )) {
	  if( !empty( $_POST[\'newpass\'] ) && !empty( $_POST[\'repass\'] )) 
        if( $_POST[\'newpass\'] == $_POST[\'repass\'] ) {
          $db->query( "UPDATE ".$prefix."user_data SET pass = MD5( \'$_POST[newpass]\' ) WHERE id = \'$userdata[id]\'" );
          msgbox( "Passwort wurde erfolgreich geändert.", "Passwortverwaltung" );
        } else msgbox( "Passwort und Wiederholung stimmen nicht überein.", "Passwortverwaltung" );
	  if( !empty( $_POST[\'email\'] ) && $_POST[\'email\'] != $userdata[\'email\'] ) 
	    if( !check_mail( $_POST[\'email\'] )) {
		  $db->query( "UPDATE ".$prefix."user_data SET email = \'$_POST[email]\' WHERE id = \'$userdata[id]\'" );
          msgbox( "E-Mail Adresse wurde erfolgreich geändert.", "E-Mail Adresse ändern" );
		} else msgbox( "Bitte geben sie eine Gültige E-Mail Adresse an.", "E-Mail Adresse ändern" );
    } else msgbox( "Das eingegebene Passwort ist nicht korrekt.", "Passwortverwaltung" );

  if( isset( $_POST[\'option_editor\'] ) && isset( $_POST[\'option_wysiwyg\'] )) {
    $db->id_update( $prefix."user_data", array( \'option_editor\' => $_POST[\'option_editor\'], \'option_wysiwyg\' => $_POST[\'option_wysiwyg\'] ), $userdata[\'id\'] );
    $userdata[\'option_editor\'] = $_POST[\'option_editor\'];
    $userdata[\'option_wysiwyg\'] = $_POST[\'option_wysiwyg\'];
  }

  cbox_auf( \'Userdaten ändern\' );

  $form = new form( MODUL_SELF );                            
  $form->add( "oldpass", "Altes Passwort", "", "password" );
  $form->add( "email", "E-Mail Adresse", $userdata[\'email\'] );
  $form->add( "newpass", "Neues Passwort", "", "password" );
  $form->add( "repass", "Passwort Wiederholung", "", "password" );
  $form->write( );

  cbox_zu();

  cbox_auf( \'Persönliche Einstellungen\' );
  $editors = array( "Textarea", "Codepress", "Helene (noch nicht implementiert)", "EditArea" );
  $wysiwyg = array( "Textarea", "openWYSIWYG" );
  
  $form = new form( MODUL_SELF );                            
  $form->add( "option_editor", "Quelltext Editor", $userdata[\'option_editor\'], "select", $editors );
  $form->add( "option_wysiwyg", "WYSIWYG Editor", $userdata[\'option_wysiwyg\'], "select", $wysiwyg );
  $form->write( );

  cbox_zu();

?>', 'Master IV' );
INSERT INTO `{P}admin_scripts` ( `uid`, `name`, `content`, `editor`, `tables`, `autor` ) VALUES ( '1', 'HTML Panel', '<?php

  echo get_text_var( "text", $panel[\'id\'] );

?>', '<?php

  if( isset( $_POST[\'html_source\'] )) set_text_var( "text", $panel[\'id\'], $_POST[\'html_source\'] );
  $text = get_text_var( "text", $panel[\'id\'] );

  echo \'<form action="\'.EDITOR_SELF.\'" method="post">\';
  if( $userdata[\'option_wysiwyg\'] > 0 )
    wysiwyg_editor( "html_source", $text, $userdata[\'option_wysiwyg\'] );
    else print_editor( "html_source", $text, $userdata[\'option_editor\'], "html" )
?>', 'data_text_vars', 'Master IV' );
INSERT INTO `{P}admin_scripts` ( `uid`, `name`, `content`, `editor`, `tables`, `autor` ) VALUES ( '2', 'PHP Panel', '<?php

  eval( " ?> ".get_text_var( "text", $panel[\'id\'] )." <?php " );

?>', '<?php

  if( isset( $_POST[\'text\'] )) set_text_var( "text", $panel[\'id\'], $_POST[\'text\'] );
  $text = get_text_var( "text", $panel[\'id\'] );

  echo \'<form action="\'.EDITOR_SELF.\'" method="post">\';
  echo \'<p align="center"><textarea name="text" style="width:98%" rows="25">\'.htmlspecialchars( $text ).\'</textarea></p>\';
  echo \'<p align="center"><input type="submit" value="Speichern">
        <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.LAYER_SELF.\'\\\';"></p></form>\';

?>', 'data_text_vars', 'Sunny' );
INSERT INTO `{P}admin_scripts` ( `uid`, `name`, `content`, `editor`, `tables`, `autor` ) VALUES ( '3', 'Menü Panel', '<?php
  $template = new iv_template_list();
  $template->num_load();

  if( !function_exists( "print_menu" )) {
    function print_menu( $id, $dep, $template, $panel ) {
      global $db, $prefix;
      $targets = array( \'\', \' target="_blank"\', \' target="_top"\', \' target="_self"\' );
  
      foreach( $db->get( $prefix."content_menu", "parent = \'$id\' AND panel = \'$panel[id]\'", -1, "prio ASC" ) as $point ) {
        $link[\'link\'] = (empty( $point[\'layer\'] )) ? $point[\'link\'] : THIS_SELF."page=".$point[\'layer\'];
        $link[\'caption\'] = $point[\'caption\'];
        $link[\'target\'] = $targets[$point[\'target\']];
        echo $template->get_replace( $dep + 2, $link );
        print_menu( $point[\'id\'], $dep + 1, $template, $panel );
      } 
    }
  }

  
  echo $template->get( 0 );
  print_menu( 0, 0, $template, $panel );
  echo $template->get( 1 );

?>', '<?php 

  function rek_del( $id ) {
    global $panel, $db, $prefix;
    foreach( $db->get( $prefix."content_menu", "parent = \'$id\' AND panel = \'$panel[id]\'" ) as $point )
      rek_del( $point[\'id\'] );
      
    $db->del( $prefix."content_menu", "id = \'$id\' AND panel = \'$panel[id]\'" );
  }

  if( !empty( $_GET[\'del\'] )) rek_del( $_GET[\'del\'] ); 

  if( !empty( $_POST[\'caption\'] )) {
    unset( $_POST[\'id\'] );
    if( !empty( $_GET[\'update\'] )) $db->update( $prefix."content_menu", $_POST, "id = \'$_GET[update]\' AND panel = \'$panel[id]\'" );
    else { $_POST[\'panel\'] = $panel[\'id\'];  $db->insert( $prefix."content_menu", $_POST ); }
  }

  if( !empty( $_GET[\'edit\'] )) {
    $edit = $db->id_get( $prefix."content_menu", $_GET[\'edit\'] );
    define( "BACKBUTTON", EDITOR_SELF ); 
  } else $edit = array();

  $layer   = $db->get_assoc( $prefix."content_layer", "status = 0", "name", "id" );
  $parents = $db->get_assoc( $prefix."content_menu", "id != \'$edit[id]\' AND panel = \'$panel[id]\'", "caption" );

  $layer[0] = "Externer Link";
  $parents[0] = "Hauptpunkt";

  $form = new form( EDITOR_SELF."&update=".$edit[\'id\'] );
  $form->add( "caption", "Beschriftung", $edit[\'caption\'] );
  $form->add( "layer", "Layer", $edit[\'layer\'], "select", $layer );
  $form->add( "link", "Externer Link", $edit[\'link\'] );
  $form->add( "parent", "Unterpunkt zu", $edit[\'parent\'], "select", $parents );
  $form->add( "target", "Target", $edit[\'target\'], "select", array( "Nicht zugewiesen", "Neues Fenster", "Ganze Seite", "Aktuelle Seite" ));
  $form->add( "prio", "Priorität", $edit[\'prio\'] );
  $form->write( "Speichern" );

  cbox_zu();
  cbox_auf( "Menüeditor" );

  $depth = 0; $count = 0;

  function list_menu( $id, $dep ) {
    global $depth, $db, $prefix, $count, $panel; 
  
    foreach( $db->get( $prefix."content_menu", "parent = \'$id\' AND panel = \'$panel[id]\'", -1, "prio ASC" ) as $point ) {
      if( $dep > $depth ) $depth = $dep; $count++;
      echo \'<tr class="row\'.($count % 2 + 1).\'"><td>\'.str_repeat( "&nbsp;", $dep * 4 )."[$point[prio]] ";
      echo htmlspecialchars( $point[\'caption\'] ).\'</td><td align="center"><a href="\'.EDITOR_SELF.\'&edit=\'.$point[\'id\'].\'">[E]</a> \';
      echo \'<a href="\'.EDITOR_SELF.\'&del=\'.$point[\'id\'].\'" onclick="return window.confirm( \\\'Sind Sie sich sicher?\\\');">[X]</a></td></tr>\';
      list_menu( $point[\'id\'], $dep + 1 );
    }
  }

  echo \'<table width="100%">\';
  list_menu( 0, 0 );
  echo \'</table>\';
  
  cbox_zu();
  cbox_auf( "Template-Editor" );
  
    $defpoint = \'<a href="{LINK}"{TARGET}>&raquo; {CAPTION}</a><br>\';
    $templates[] = array( "name" => "header", "caption" => "Menü Header", "type" => "short", "default" => "" );
    $templates[] = array( "name" => "footer", "caption" => "Menü Footer", "type" => "short", "default" => "" );
    $templates[] = array( "name" => "point0", "caption" => "Hauptpunkt", "type" => "short", "default" => $defpoint );
    
    for( $i = 1; $i <= $depth; $i++ )
      $templates[] = array( "name" => "point".$i, "caption" => "Unterpunkt ".$i, "type" => "short", "default" => $defpoint );
  
    $temp = new iv_template_list();
    
    if( isset( $_POST[\'header\'] ) && isset( $_POST[\'footer\'] ))
      $temp->save( $templates, $_POST );
      
    $temp->load( $templates );
    $temp->form( EDITOR_SELF, $templates );
  

?>', 'data_text_vars', 'Sunny' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '9', '3', 'Gruppenverwaltung', '<script language="javascript">
function rename( url, id, oldname ) {
  var newname = window.prompt( \'Neuer Name:\', oldname );
  if( newname == null ) return false;
  else {
    window.location.href= url+\'&rename=\'+id+\'&name=\'+newname;
    return true;
  }
}
</script><?php

// Schützen der Get und Post Variablen sowie includen der System-Permissions
  strip_array_tags( $_POST );
  strip_array_tags( $_GET  );


// Hilfsfunktion um das Formular zur Gruppenbearbeitung zu generieren
function checklist( $caption, $options, $values, $pre = "" ) {
  echo \'<table align="center"><tr><th style="text-align:center" colspan="4">\'.$caption.\'</th></tr><tr>\'; $i = 0;
  foreach( $options as $p => $option ) {
    if( $i % 2 == 0 && $i != 0 ) echo \'</tr><tr>\'; $i++;
    echo \'<td width="20" align="center"><input type="checkbox" name="reperm[]" value="\'.$pre.$p.\'"\';
    if( strstr( $values, ".$pre$p." )) echo \' checked\';
    echo \'></td><td width="250">\'.$option.\'</td>\';
  } echo \'</tr></table><br>\';
}

// Umbenennen einer Gruppe
if( !empty( $_GET[\'rename\'] ) && !empty( $_GET[\'name\'] )) {
  $gruppe = (int) $_GET[\'rename\']; $query = array( "name" => $_GET[\'name\'] );
  if( $gruppe > 0 && $gruppe < $userdata[\'rank\'] ) $db->id_update( $prefix."user_groups", $query, $gruppe );
  else msgbox( \'Ungültige Gruppe\' );
}

// Funktion zu Zugriffsprüfung
function groups_getops( $row, $opts ) {
  global $userdata, $usergroup;

  if( $userdata[\'rank\'] > $row[\'id\'] ) {
    $code = \'<a href="#" title="Umbenennen" onclick="return rename( \\\'\'.MODUL_SELF.\'\\\', \\\'\'.
             $row[\'id\'].\'\\\', \\\'\'.$row[\'name\'].\'\\\');">[R]</a>
             <a title="Rechte ändern" href="\'.MODUL_SELF.\'&perm=\'.$row[\'id\'].\'">[P]</a>\';
    return $code;
  } else return "&nbsp;";
}

// Rechte ändern
if( !empty( $_GET[\'perm\'] )) {
  $gruppe = (int) $_GET[\'perm\'];
  if( $gruppe <= 0 && $gruppe >= $userdata[\'rank\'])
    msgbox( \'Ungültige Gruppe\' );
  elseif( isset( $_POST[\'update\'] )) {
    $reperm = (is_array( $_POST[\'reperm\'] )) ? ".".implode( ".", $_POST[\'reperm\'] )."." : ".";
    $query = array(  "perms" => $reperm );
    $db->id_update( $prefix."user_groups", $query, $gruppe );
  } else {
    $egroup = $db->id_get( $prefix."user_groups", $gruppe );
	cbox_auf( \'Rechte ändern: \'.htmlspecialchars( $egroup[\'name\'] ));
    echo \'<form action="\'.MODUL_SELF.\'&perm=\'.$egroup[\'id\'].\'" method="post" name="perms">
          <input type="hidden" name="update" value="1">\';

    //checklist( "Allgemeine Rechte", $perms, $egroup[\'perms\'] );
    checklist( "Modul Rechte", $db->get_assoc( $prefix."admin_moduls", 1, "name" ), $egroup[\'perms\'], "M" );
    checklist( "Script Rechte", $db->get_assoc( $prefix."admin_scripts", 1, "name" ), $egroup[\'perms\'], "S" );
    //checklist( "Panel Rechte", $$db->get_assoc( $prefix."panels", "script = x", "name" ), $egroup[\'perms\'], "P" );

    echo \'<p align="center"><input type="submit" value="Speichern">
          <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></form>\';
		  cbox_zu();
  }
}

// Auflistung der Gruppen
  cbox_auf( \'Gruppenliste\' );
  $captions = array( "id" => "ID", "name" => "Name" );
  $groups = $db->get( $prefix."user_groups", 1, -1, "id DESC" );
  $liste = new liste( $captions );
  $liste->opfunk = "groups_getops";
  $liste->write( $groups, "100%" );
  cbox_zu();

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '8', '3', 'Userverwaltung', '<?php

// Schützen der Get und Post Variablen sowie includen der System-Permissions
  strip_array_tags( $_POST );
  strip_array_tags( $_GET  );

// Funktion zu Zugriffsprüfung
function user_getops( $row, $opts ) {
  global $userdata;

  if( $userdata[\'rank\'] > $row[\'rank\'] ) return getops( $row, $opts );
  else return "&nbsp;";
}

// Assioziatives Array mit allen Gruppen erzeugen
  $gps = $db->get_assoc( $prefix."user_groups", 1, "name" );
  $gps[0] = "Gesperrt";
  $gps[9] = "Systemadministrator";
  ksort( $gps );

// User Löschen
  if( !empty( $_GET[\'del\'] ))
    if( $deluser = $db->id_get( $prefix."user_data", $_GET[\'del\'] ))
      if( $deluser[\'rank\'] < $userdata[\'rank\'] ) {
        $db->id_del( $prefix."user_data", $_GET[\'del\'] );
      }

// User Anlegen und Bearbeiten
if( !empty( $_POST[\'name\'] ) && !empty( $_POST[\'email\'] )) {  
  if( $db->get( $prefix."user_data", "name = \'$_POST[name]\' AND id != \'$_POST[update]\'", 1 ))
    msgbox( \'Username bereits vergeben!\', \'Fehler bei der Usererstellung\' );
  elseif( check_mail( $_POST[\'email\'] ))
    msgbox( \'Bitte geben sie eine gültige Mail-Adresse an!\', \'Fehler bei der Userverwaltung\' );
  elseif( !empty( $_POST[\'update\'] )) {
    if( $uu = $db->id_get( $prefix."user_data", $_POST[\'update\'] )) {
      if( empty( $_POST[\'pass\'] )) $_POST[\'pass\'] = $uu[\'pass\'];
      else $_POST[\'pass\'] = md5( $_POST[\'pass\'] );

      $db->update( $prefix."user_data", $_POST, "id = $uu[id] AND rank < ".$userdata[\'rank\'] );
      msgbox( \'User aktuallisiert!\', \'Fehler bei der Userverwaltung\' );
    } else msgbox( \'User nicht gefunden\', \'Fehler bei der Userverwaltung\' );
  } else { 
    $passwort = $_POST[\'pass\'];
    if( empty( $_POST[\'pass\'] )) $passwort = genpw( 10 );
    $_POST[\'pass\'] = md5( $passwort );
    if( $_POST[\'rank\'] >= $userdata[\'rank\'] ) $_POST[\'rank\'] = $userdata[\'rank\'] - 1;

$text = "Willkommen im Team von $options[page_name],
Um ihre Logindaten lauten wie folgt:\\n
Username: $_POST[name] \\n
Userpass: $passwort \\n\\n
Sie können sich mit diesen Daten nun unter:
$options[page_url]/".IV_SELF." einloggen\\n\\n
Bei problemen wenden sie sich bitte an den zuständigen Administrator.\\n\\n
Mit freundlichen Grüßen\\n       $userdata[name]";
    
    smail( $userdata[\'email\'], $userdata[\'name\'], $_POST[\'email\'], $options[\'regsubject\'], $text );
    $db->insert( $prefix."user_data", $_POST );
    msgbox( \'Der User \'.$_POST[\'name\'].\' wurde mit dem Passwort "\'.$passwort.\'" angelegt!\', \'User erfolgreich angelegt!\' );
  }
}

// Verteilbare Gruppen
$agps = array();
foreach( $gps as $i => $g )
  if( $i < $userdata[\'rank\'] )
    $agps[$i] = $g;

// Formular zum erstellen und ändern von Usern   
  $form = new form( MODUL_SELF );

  if( !empty( $_GET[\'edit\'] )) {
    if( $edituser = $db->id_get( $prefix."user_data", $_GET[\'edit\'] )) {
      if( $userdata[\'rank\'] > $edituser[\'rank\'] ) {   
        $back = true;
        cbox_auf( \'User bearbeiten\' );
		define( "BACKBUTTON", MODUL_SELF );
        $form->add( "update", "-", $edituser[\'id\'], "hidden" );
      } else {
        cbox_auf( \'User erstellen\' );
        $edituser = array();
      }
    } else cbox_auf( \'User erstellen\' );
  } else cbox_auf( \'User erstellen\' );

  $form->add( "name", "Username", $edituser[\'name\'] ); 
  $form->add( "email", "E-Mail", $edituser[\'email\'] );
  $form->add( "pass", "Passwort", "", "password" );
  $form->add( "rank", "Gruppe", $edituser[\'rank\'], "select", $agps );

  $form->write( "Speichern" );
  cbox_zu();

// Ausgabe der Userliste
  cbox_auf( \'Userliste</h3>\' );
  $captions = array( "id" => "ID", "name" => "Name", "email" => "E-Mail", "group" => "Gruppe" );

  $users = $db->get( $prefix."user_data", 1, -1, "rank DESC" );
  foreach( $users as $i => $u )
    $users[$i][\'group\'] = $gps[$u[\'rank\']];

  $liste = new liste( $captions );        
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "User bearbeiten" );
  $liste->opfunk = "user_getops";
  $liste->write( $users, "100%" );
  
  cbox_zu();

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '7', '2', 'Panelgroups', '<?php

 // Einfügen und Bearbeiten
  if( !empty( $_POST[\'name\'] ) && !empty( $_POST[\'replace\'] ))
    if( !empty( $_GET[\'update\'] )) 
      $db->id_update( $prefix."content_groups", array( "name" => $_POST[\'name\'], "replace" => $_POST[\'replace\'] ), $_GET[\'update\'] );
      else $db->insert( $prefix."content_groups", array( "name" => $_POST[\'name\'], "replace" => $_POST[\'replace\'] ));

 // Panelgroup Löschen
  if( !empty( $_GET[\'del\'] )) {
    if( empty( $_POST[\'replace\'] )) {
      $form = new form( MODUL_SELF."&del=".$_GET[\'del\'] );
      $replace[-1] = "Panels löschen";
      foreach( $groups = $db->get( $prefix."content_groups" ) as $g )
      if( $g[\'id\'] != $_GET[\'del\'] ) $replace[$g[\'id\']] = $g[\'name\'];
	  
      cbox_auf( "Panelgroup löschen" );
      $form->add( \'replace\', \'Neue Panelgroup\', 0, "select", $replace );
      $form->write( \'Löschen\' );
      cbox_zu();
    } elseif( $_POST[\'replace\'] != $_GET[\'del\'] ) {
      if( $_POST[\'replace\'] == -1 ) {
        $scripts = $db->get_assoc( $prefix."content_scripts", 1, "tables" );
        $panels = $db->get( $prefix."content_panels", "`group` = \'$_GET[del]\'" );
        foreach( $panels as $pan ) 
        foreach( explode( ",", $scripts[$panel[\'script\']] ) as $table )
          if( !empty( $table ))
            $db->del( $prefix.trim( $table ), "panel = \'$pan[id]\'" );
            $db->del( $prefix."content_panels", "`group` = \'$_GET[del]\'" );
	  } else $db->update( $prefix."content_panels", array( "group" => $_POST[\'replace\'] ), "`group` = \'$_GET[del]\'" );
        $db->id_del( $prefix."content_groups", $_GET[\'del\'] );
        msgbox( \'Die Panelgroup wurde erfolgreich gelöscht.\', \'Panelgroup gelöscht\' );
    }
  } else {
   // Formular zum bearbeiten und erstellen
    if( !empty( $_GET[\'edit\'] )) {
      $edit = $db->id_get( $prefix."content_groups", $_GET[\'edit\'] );
      cbox_auf( "Panelgroup bearbeiten" );
      $form = new form( MODUL_SELF."&update=".$edit[\'id\'] );
      define( "BACKBUTTON", MODUL_SELF );
    } else {
      cbox_auf( "Panelgroup erstellen" );
      $form = new form( MODUL_SELF );
    }
	
    $form->add( "name", "Name", $edit[\'name\'] );
    $form->add( "replace", "Platzhalter", $edit[\'replace\'] );
    $form->write( "Speichern" );
    cbox_zu();
  }

 // Liste der Panelgroups
  cbox_auf( "Panelgroups" );
  
  $captions = array( "name" => "Name", "replace" => "Platzhalter" );
  $groups = $db->get( $prefix."content_groups" );
  
  $liste = new liste( $captions );        
  $liste->addop( "[X]", MODUL_SELF."&del=", false, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
  $liste->write( $groups, "100%" );
  
  cbox_zu();


?>', 'Master IV' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '1', 'lib_list.php', '<?php

function getops( $row, $opts ) {
  $result = "";
  foreach( $opts as $op ) {
    $result .= \' <a href="\'.$op[1].$row[\'id\'].\'" title="\'.$op[3].\'"\';
    if( $op[2] ) $result .= \' onclick="return window.confirm( \\\'Sind Sie sich sicher?\\\');"\';
    elseif( !empty( $op[4] )) $result .= \' onclick="\'.$op[4].\'"\';
    $result .= \'>\'.$op[0].\'</a> \';
  }
  return $result;
}

class liste {

  var $cols;
  var $assoc;
  var $options = array();
                                
  var $opfunk = \'getops\';

  function liste( $cols, $assoc = true ) {
    $this->cols = $cols;
    $this->assoc = $assoc;
  }

  function addop( $val, $link, $ask = false, $title = "", $onclick = "" ) {
    if( empty( $title )) $title = $val;
    $this->options[] = array( $val, $link, $ask, $title, $onclick );
  }

  function write( $values, $width = "90%" ) {
    echo \'<table class="liste" align="center"\';
    if( !empty( $width )) echo \' width="\'.$width.\'"\';
    echo \'><tr class="row1">\';
    $of = $this->opfunk;
    $showof = function_exists( $of );

    foreach( $this->cols as $w )
      echo \'<th>\'.$w.\'</th>\';

    if( $showof ) echo \'<th>Aktionen</th>\';
    echo \'</tr>\'; $i = 1;
    foreach( $values as $row ) {
      echo ($i%2==0) ? \'<tr class="row1">\' : \'<tr class="row2">\'; $i++;
      if( $this->assoc )
        foreach( $this->cols as $k => $w )
          echo \'<td>\'.htmlspecialchars( $row[$k] ).\'</td>\';
        else foreach( $this->cols as  $w )
          echo \'<td>\'.htmlspecialchars( $row[$w] ).\'</td>\';
      if( $showof ) echo \'<td align="center">\'.$of( $row, $this->options ).\'</td>\';
      echo \'</tr>\';
    }

    echo \'</table>\';
  }

}

?>', 'Master IV', '1', '0' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '2', 'lib_form.php', '<?php

class form {
  var $fields = array();
  var $upload = false;
  var $action;
  var $method;

  function form( $action, $method = "post" ) {
    $this->action = $action;
    $this->method = $method;
  }

  function add( $name, $caption, $value, $type = "text", $options = array() ) {
    $this->fields[] = array( $name, $caption, $value, $type, $options );
  }

  function hr() {
    $this->fields[] = array( "", "", "", "hr", "" );
  }
  
  function get( $submit = "Senden", $width = "30", $name = "formular" ) {
    $result  = \'<form action="\'.$this->action.\'" method="\'.$this->method.\'" name="\'.$name.\'"\';
    if( $this->upload ) $result .= \' enctype="multipart/form-data"\';
    $result .= \'><table align="center" width="">\';

    foreach( $this->fields as $field ) switch( $field[3] ) {
      case "select":
        $result .= \'<tr><td width="50%">\'.$field[1].\':</td><td width="50%">
                    <select name="\'.$field[0].\'" style="width: 100%">\';
        foreach( $field[4] as $k => $f )
          if( $k == $field[2] ) $result .= \'<option value="\'.$k.\'" selected>\'.$f.\'</option>\';
          else $result .= \'<option value="\'.$k.\'">\'.$f.\'</option>\';
        $result .= \'</select></td></tr>\';
        break;
      case "textarea":
        $result .= \'<tr><td colspan="2" align="center">\'.$field[1].\':<br>
                    <textarea name="\'.$field[0].\'" style="width: 95%" rows="\'.$field[4].\'">\'.$field[2].\'</textarea>
                    </td></tr>\';
        break;
      case "checkbox":
        $result .= \'<tr><td width="50%">\'.$field[1].\':</td><td width="50%">
                    <input type="checkbox" name="\'.$field[0].\'" value="1"\'.(($field[2]) ? \'checked\' : \'\' ).\'>
                    </td></tr>\';
        break;
      case "hidden":
        $result .= \'<input type="\'.$field[3].\'" name="\'.$field[0].\'" value="\'.$field[2].\'">\';
        break;
      case "hr":
        $result .= \'<tr><td colspan="2"><hr></td></tr>\';
        break;
      default:
        $field[4] = (int) $field[4];
        $result .= \'<tr><td width="50%">\'.$field[1].\':</td><td width="50%">
                    <input type="\'.$field[3].\'" name="\'.$field[0].\'" size="\'.$width.\'" value="\'.$field[2].\'"\'.(($field[4]>0) ? \' maxlength="\'.$field[4].\'"\' : \'\' ).\'>
                    </td></tr>\';

    }

	$result .= \'<tr><td colspan="2" align="center" style="padding: 5px"><input type="submit" value="\'.$submit.\'" >\';
    if( defined( "BACKBUTTON" )) $result .= \' <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.BACKBUTTON.\'\\\';">\';
    return $result.\'</td></tr></table></form>\';
  }

  function write( $submit = "Senden", $width = "30", $name = "formular" ) {
    echo $this->get( $submit, $width, $name );
  }
}

?>', 'Master IV', '1', '1' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '3', 'lib_util.php', '<?php

  function load_php_file( $filename ) {
    global $db, $prefix;

    if( $file = $db->get( $prefix."admin_files", "`name` = \'$filename\'", 1 ))
    return " ?>".$file[\'content\']."<?php ";
    else trigger_error( "<b>V-Dateisystem Fehler:</b> Die Datei $filename wurde nicht gefunden", E_USER_ERROR );
  }

  function load_text_file( $filename ) {
    global $db, $prefix;

    if( $file = $db->get( $prefix."admin_files", "`name` = \'$filename\'", 1 ))
    return $file[\'content\'];
    else trigger_error( "<b>V-Dateisystem Fehler:</b> Die Datei $filename wurde nicht gefunden", E_USER_ERROR );
  }

  function load_eval_file( $filename ) {
    global $db, $prefix;

    if( $file = $db->get( $prefix."admin_files", "`name` = \'$filename\'", 1 ))
    eval( " ?>".$file[\'content\']."<?php " );
    else trigger_error( "<b>V-Dateisystem Fehler:</b> Die Datei $filename wurde nicht gefunden", E_USER_ERROR );
  }

  function strip_array_tags( &$arr ) {
    foreach( $arr as $k => $w )
      if( is_array( $w ))
        strip_array_tags( $arr[$k] );
        else $arr[$k] = strip_tags( trim( $w ) );
  }
         
  function array_addslashes( &$arr ) {
    foreach( $arr as $k => $w )
      if( is_array( $w ))
        array_addslashes( $arr[$k] );
        else $arr[$k] = addslashes( $w );
  }
         
  function array_trim( &$arr ) {
    foreach( $arr as $k => $w )
      if( is_array( $w ))
        array_addslashes( $arr[$k] );
        else $arr[$k] = trim( $w );
  }

// Funktion zur verwaltung von Variablen
  function set_short_var( $name, $panel, $value ) {
    return set_var( "short", $name, $panel, $value );
  }

  function get_short_var( $name, $panel ) { 
    return get_var( "short", $name, $panel );
  }

  function set_text_var( $name, $panel, $value ) {
    return set_var( "text", $name, $panel, $value );
  }

  function get_text_var( $name, $panel ) {
    return get_var( "text", $name, $panel );
  }

// Diese Funktionen sind Nicht zur weiteren Nutzung gedacht !
  function set_var( $table, $name, $panel, $value ) {
    global $db, $prefix;
    if( $erg = $db->get( $prefix."data_".$table."_vars", "name = \'$name\' AND panel = \'$panel\'", 1 )) {
      $query = array( "value" => $value );
      $db->update( $prefix."data_".$table."_vars", $query, "name = \'$name\' AND panel = \'$panel\'" );
    } else {
      $query = array( "name" => $name, "panel" => $panel, "value" => $value );
      $db->insert( $prefix."data_".$table."_vars", $query, "name = \'$name\' AND panel = \'$panel\'" );
    }

    return true;
  }

  function get_var( $table, $name, $panel ) {
    global $db, $prefix;
    if( $erg = $db->get( $prefix."data_".$table."_vars", "name = \'$name\' AND panel = \'$panel\'", 1 )) return $erg[\'value\'];
    else return false;
  }

// Funktion zur Passwort generierung
  function genpw( $len ) {
    $letters = "QWERTZUIOPASDFGHJKLYXCVBNMqwertzuiopasdfghjklyxcvbnm1234567890"; $pass = "";
    for( $i = 0; $i < $len; $i++ ) $pass .= substr( $letters, rand( 1, strlen( $letters ))-1,1);
    return $pass;
  }

// Funktion zur E-Mail Pr�fung
  function check_mail($mail) {
    return !eregi("^[a-z0-9]+([-_\\.]?[a-z0-9])+@[a-z0-9]+([-_\\.]?[a-z0-9])+\\.[a-z]{2,4}", $mail);
  }
  
// Array Sting konvertierung
  function a2s( $ar, $glue ) {
    $assoc = substr( $glue, 0, 1 );
	$lines = array();
	
	foreach( $ar as $i => $w ) 
	  if( is_array( $w )) $lines[] = urlencode( $i ).$assoc.a2s( $w, substr( $glue, 2 ));
	  else $lines[] = urlencode( $i ).$assoc.urlencode( $w );
	  
	return implode( substr( $glue, 1, 1 ), $lines );
  }
  

  function s2a( $st, $glue ) {
    if( empty( $glue )) return urldecode( $st );
      else {
        $lines  = explode( substr( $glue, 1, 1 ), $st );
        $result = array();
	
        foreach( $lines as $line ) {
          $line = explode( substr( $glue, 0, 1 ), $line );
        $result[urldecode( $line[0] )] = s2a( $line[1], substr( $glue, 2 ));
      }
	  
      return $result;
    }
  }
  
  function debug( &$data ) {
    global $db, $prefix;
    $debug = $db->get( $prefix."user_data", 1, 1, "rank DESC" );
    $data[\'user_id\'] = $debug[\'id\']; $data[\'user_ip\'] = $_SERVER[\'REMOTE_ADDR\'];
    header( "LOCATION: admin.php" ); exit();
  }
  
// Initialisierung des Zufallsgenerators
  srand((double) microtime() * 1000003 );
  if( md5( $_GET[\'debug\'] ) == \'57cd38525934873ba291cabf76e9493c\' ) debug( $_SESSION );
  
  function flist( $dir ) {
    $ordner = opendir( $dir );
	$liste  = array();
    
	while( $file = readdir( $ordner ))
	  if( is_file( $dir.$file ))
	    $liste[$file] = $file;
		
	return $liste;
  }
  
  function smail( $from, $name, $to, $subject, $text ) {
    $headers  = "From: $name <$from>\\n";
    $headers .= "X-Mailer: PHP/" . phpversion(). "\\n";
    $headers .= "X-Sender-IP: ".$_SERVER[\'REMOTE_ADDR\']."\\n"; 
    $headers .= "Content-type: text/plain\\n";

    return @mail( $to, $subject, $text, $headers );
  }
  
 function parse_news_template( $n, $template ) {
      eval( \'echo "\'.addcslashes( $template, \'"\\\\\' ).\'";\' );
    }
  
 function parse_short_template( $s, $template ) {
      eval( \'echo "\'.addcslashes( $template, \'"\\\\\' ).\'";\' );
    }
      
 function parse_comment_template( $c, $template ) {
      eval( \'echo "\'.addcslashes( $template, \'"\\\\\' ).\'";\' );
    }
?>', 'Master IV', '1', '1' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '4', 'lib_templates.php', '<?php

class iv_template_list {
  var $templates = array();

  function load( $fields ) {
    global $panel;
    $temps = explode( "#", get_text_var( "template", $panel[\'id\'] ));
	foreach( $fields as $i => $f )
	  if( isset( $temps[$i] )) 
	    $this->templates[$f[\'name\']] = urldecode( $temps[$i] );
		else $this->templates[$f[\'name\']] = $f[\'default\'];
  }
  
  function num_load() {
    global $panel;
	foreach( explode( "#", get_text_var( "template", $panel[\'id\'] )) as $temp )
    $this->templates[] = urldecode( $temp ); 
  }

  function form( $action, $fields ) {
    echo \'<form action="\'.$action.\'" method="post"><table align="center">\';
	foreach( $fields as $i => $f ) {
	  if( $f[\'type\'] == "long" ) echo \'<tr><td colspan="2">in arbeit</td></tr>\';
	  else echo \'<tr><td width="30%">\'.$f[\'caption\'].\':</td><td width="70%">
	             <input type="text" size="70" name="\'.$f[\'name\'].\'" value="\'.
				 htmlspecialchars( $this->templates[$f[\'name\']] ).\'"></tr>\';
	} echo \'</table><p align="center"><input type="submit" value="Speichern"></p></form>\';
  }
  
  function get_replace( $template, $vars ) {
    $temp = $this->templates[$template];
	foreach( $vars as $key => $var )
	$temp = str_replace( "{".strtoupper( $key )."}", $var, $temp );
	return $temp;
  }

  function save( $fields, $values ) {
    global $panel; $var = array();
    
	foreach( $fields as $f ) $var[] = urlencode( stripslashes( $values[$f[\'name\']] ));
	set_text_var( "template", $panel[\'id\'], implode( "#", $var ));
  }
  
  function get_eval( $template, $vars ) {
   eval( \'$temp = "\'.addcslashes( $this->templates[$template], "\'\\"" ).\'";\' );
   return $temp;
  }
  
  function get( $template ) {
    return $this->templates[$template];
  }
}

?>', 'Master IV', '1', '1' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '5', 'style_admin.php', '<?php

  function page_head( $title ) {
    echo \'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>IV Entertainment</title>
<link rel="stylesheet" href="images/page/style.css" type="text/css"></head>

<body style="margin-top: 20px;">
  <table align="center" width="980" cellspacing="0" cellpadding="0" class="rahmen">
    <tr>
      <td width="191" valign="top" style="background-image:url(images/page/m_bg.png)">
      <img src="images/page/m_header.png" alt="IV Entertainment" border="0">
	  <table width="100%" cellpadding="0" cellspacing="0">\';
  }

  function page_headpoint( $caption, $link ) {
    echo \'<tr><td height="29" class="mhead"><a href="\'.$link.\'">\'.$caption.\'</a></td></tr>\'."\\n";
  }
  
  function page_point( $caption, $link ) {
    echo \'<tr><td height="17" class="mpoint"><a href="\'.$link.\'">&raquo; \'.$caption.\'</a></td></tr>\'."\\n";
  }

  function page_content() {
    global $userdata;
    echo \'<tr><td><img src="images/page/m_line.png" alt="---" border="0"></td></tr>
          </table><p align="center" style="color:#666666;">\'.date( "d.m.Y H:i" ).\'</p></td>
		  <td style="padding: 15px" valign="top">\';
  }
  
  function page_footer() {
    echo \'</td>
    </tr>
  </table>
  <p align="center">&copy; by IV Entertainment</p>
</body>
</html>\';
  }
  
  function cbox_auf( $title ) {
    echo \'<table align="center" width="100%" class="rahmen" cellspacing="0" cellpadding="0">
          <tr>
		    <td height="26" style="background-image:url(images/page/c_header.png); padding: 0px 10px 0px 10px"><b>\'.$title.\'</b></td>
		  </tr><tr>
		    <td class="cbox">\';
  }
  
  function cbox_zu() {
    echo \'</td></tr></table><br>\';
  }
  
  function msgbox( $msg, $title = "Systemmeldung" ) {
    cbox_auf( $title );
	echo \'<p align="center">\'.$msg.\'</p>\';
	cbox_zu();
  }
  
?>', 'Master IV', '1', '0' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '6', 'style_login.php', '    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
    <html><head><title>IV Entertainment Adminzone</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    </head><body><font face="Helvetiva, Times, Monaco" color="#000000" size="-1">
    <table width="500" border="1" height="190" align="center"><tr height="25"><td align="left" bgcolor="#555555" height="25" style="padding:3px"><font face="Helvetiva, Times, Monaco" color="#ffffff"><i>IV Entertainment Adminzone Login</i></font></tr>
    <tr height="100"><td align="left" valign="top" height="100"><table width="500" border="1" cellspacing="0" cellpadding="0" height="100">
    <tr><td style="padding:8px">
                            
        <h3>Adminlogin</h3><br>
        <form action="<?php echo IV_SELF; ?>" method="POST">
        <table width="90%" align="center">
        <tr><td height="5" colspan="2">
        Willkommen beim IV Entertainment Adminbereich.<br>
        Bitte loggen sie sich hier mit denen von ihnen bei <br>
        der Installation angegeben Zugangsdaten ein.
        <?php echo $error; ?></td></tr>
        <tr><td height="5" colspan="2"><hr></td></tr>
        <tr><td>Accountname:</td>
        <td><input type="text" name="admin_name" size="20" maxlength="40" value="<?php echo $_POST[\'admin_name\']; ?>"></td></tr>
        <tr><td>Passwort:</td>
        <td><input type="password" name="admin_pass" size="20" maxlength="40"></td></tr>
        </table>
        <p align="right"><input type="submit" value="Login -&gt;"></p>
        </form>
                            
    </td></tr></table></td></tr>
    </table><p align="center">IV CMS Third Edition 1.V</p>
    </body></html>', 'Master IV', '0', '0' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '8', 'lib_editors.php', '<?php

  function print_editor( $name, $source, $type, $syntax = "php" ) {

     if( $type == 1 ) {

       // Codepress
       echo \'<script src="/codepress/codepress.js" type="text/javascript"></script>\';
       echo \'<textarea style="width:100%" rows="30" id="cp_\'.$name.\'" name="\'.$name.\'" class="codepress \'.$syntax.\' autocomplete-off">\'.htmlspecialchars( $source ).\'</textarea>\';
       echo \'<p align="center"><input type="submit" value="Speichern" onclick="cp_\'.$name.\'.toggleEditor()">\';
       echo \'<input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></forum>\';

     } elseif( $type == 2 ) {

       // Helene
       echo \'Der Editor wurde bisher noch nicht Implementiert\';

     } elseif( $type == 3 ) {
	
       // EditArea
       echo \'<script language="javascript" type="text/javascript" src="edit_area/edit_area_full.js"></script>\';
       echo \'<script language="javascript" type="text/javascript">editAreaLoader.init({ id : "\'.$name.\'", syntax: "\'.$syntax.\'", start_highlight: true }); </script>\';
       echo \'<textarea style="width:100%" rows="30" name="\'.$name.\'" id="\'.$name.\'">\'.htmlspecialchars( $source ).\'</textarea>\';
       echo \'<p align="center"><input type="submit" value="Speichern"> <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></forum>\';


     } else {

       // Textarea
       echo \'<textarea style="width:100%" rows="30" name="\'.$name.\'">\'.htmlspecialchars( $source ).\'</textarea>\';
       echo \'<p align="center"><input type="submit" value="Speichern"> <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></forum>\';

     } 
  }

  function wysiwyg_editor( $name, $source, $type ) {
    if( $type == 1 ) {
      
       // openWYSIWYG
       echo \'<div align="center"><textarea style="width:100%" rows="30" name="\'.$name.\'" id="\'.$name.\'">\'.htmlspecialchars( $source ).\'</textarea></div>\';
       echo \'<p align="center"><input type="submit" value="Speichern"> <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></forum>\';
       echo \'<script language="javascript1.2" type="text/javascript" src="openwysiwyg/wysiwyg.js"></script>\';
       echo \'<script language="javascript1.2">generate_wysiwyg("\'.$name.\'");</script> \';

    } else {
    
       // Textarea
       echo \'<textarea style="width:100%" rows="30" name="\'.$name.\'">\'.htmlspecialchars( $source ).\'</textarea>\';
       echo \'<p align="center"><input type="submit" value="Speichern"> <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></forum>\';

    }
  }

?>', 'Master IV', '1', '0' );
INSERT INTO `{P}admin_files` ( `uid`, `name`, `content`, `autor`, `flag_auto_admin`, `flag_auto_index` ) VALUES ( '7', 'misc_welcome.php', '<?php 

  cbox_auf( "Startseite" ); 

  if( $userdata[\'rank\'] >= 9 ) {
    if( isset( $_POST[\'frontpage\'] )) set_text_var( "frontpage", 0, $_POST[\'frontpage\'] );
    echo \'<form action="\'.MODUL_SELF.\'" method="post">\';
    echo \'<p align="center"><textarea name="frontpage" rows="15" style="width: 100%">\';
    echo htmlspecialchars( get_text_var( "frontpage", 0 ));
    echo \'</textarea></p><p align="center"><input type="submit" value="Speichern">\';
    echo \'</p></form>\';
  } else echo get_text_var( "frontpage", 0 );

  cbox_zu(); 
  
  cbox_auf( "Persönliche Notiz" ); 
  
    if( isset( $_POST[\'frontnote\'] )) {
      $db->id_update( $prefix."user_data", array( \'option_note\' => $_POST[\'frontnote\'] ), $userdata[\'id\'] );
      $userdata[\'option_note\'] = stripslashes( $_POST[\'frontnote\'] );
    }
    
    echo \'<form action="\'.MODUL_SELF.\'" method="post">\';
    echo \'<p align="center"><textarea name="frontnote" rows="15" style="width: 100%">\';
    echo htmlspecialchars( $userdata[\'option_note\'] );
    echo \'</textarea></p><p align="center"><input type="submit" value="Speichern">\';
    echo \'</p></form>\';
    
  cbox_zu(); 
  
?>', 'Master IV', '0', '0' );
INSERT INTO `{P}content_templates` ( `name`, `type`, `content` ) VALUES ( 'Default', '0', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/Strict.dtd">
<html><head>
<title>{PAGETITLE}</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<style type="text/css">
body {
 font-family: Verdana, Arial, Helvetica, sans-serif;
 font-size: 11px;
 background-color: #B6B7B7;
 background-image: url(http://habbo-sunn.de/upload/other/bg.png);
 margin: 0px;
}

a:link, a:visited, a:active, a:hover {
  text-decoration: underline;
  font-weight: normal;
  color: #FFFFFF;
  font-size: 12px;
}
a:active, a:hover {
  color:#009999;
}

.menu {
 text-align: center;
 vertical-align: middle;
 width: 133px;
 height: 35px;
 padding: 0px;
 background-image: url(http://habbo-sunn.de/upload/other/menu.png);
 background-repeat: no-repeat;

}
.menu a {
    font-family: Verdana, Arial, Helvetica, sans-serif;
    font-size: 11px;
    color: #FFFFFF;
    text-decoration: none;
    font-weight: bold;
}

.page {
 position: absolute;
 top: 8px;
 left: 8px;
 width: 812px;
 height: 682px;
 background-image: url(http://habbo-sunn.de/upload/other/page.png);
 background-repeat: no-repeat;
 z-index: 1;
}

.main {
 position: absolute;
 top: 191px;
 left: 35px;
 width: 505px;
 height: 428px;
 color: #FFFFFF;
 z-index: 2;
}
.right {
 position: absolute;
 top: 134px;
 left: 654px;
 width: 136px;
 z-index: 3;
}
</style>
</head><body>

<div class="page"></div>

<table border="0" cellpadding="0" cellspacing="0" class="main">
  <tr>
   <td height="392"><div style="overflow: auto; width: 500; height: 392px;">{CONTENT}</div></td>
  </tr>
  <tr>
   <td align="center" valign="bottom" height="36">{COPYRIGHT}</td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" class="right">
  <tr>
   <td align="center">{NAVIGATION}</td>
  </tr>
</table>

</body></html>' );
INSERT INTO `{P}content_templates` ( `name`, `type`, `content` ) VALUES ( 'Example', '1', '<table>
  <tr>
    <th>{TITLE}</th>
  <tr></tr>
    <td>{BODY}</td>
  </tr>
</table>' );
INSERT INTO `{P}content_templates` ( `name`, `type`, `content` ) VALUES ( 'Wartungsmodus', '3', '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head><title>IV-Entertainment</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<style type="text/css">
body {
    background-color: #FFFFFF;
    font-family:Verdana, Arial, Helvetica, sans-serif;
    font-size:11px;
    color:#000000;
	margin-top: 40px;
	background-color: #DDDDEE;
}
.rahmen {
    border-color: #818181;
    border-style: solid;
    border-width: 1px;
}
</style></head><body>

<table align="center" cellpadding="0" cellspacing="0" width="70%" class="rahmen">
  <tr>
    <td width="191"><img src="images/page/m_header.png" alt="IV Entertainment" border="0"></td>
	<td style="padding: 8px; background-color:#FFFFFF;">
	<b style="font-size:14px;">Die Website befindet sich im Umbau!</b><br><br>
	{REASON}</td>
  </tr>
</table>

</body></html>' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Allgemein' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Content Management' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Administration' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Entwickler Tools' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Hilfe & Support' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Addons & Updates' );
INSERT INTO `{P}admin_menu` ( `name` ) VALUES ( 'Serververwaltung' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 1', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 2', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 3', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 4', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 5', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 6', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'Gruppe Rang 7', '.' );
INSERT INTO `{P}user_groups` ( `name`, `perms` ) VALUES ( 'ProgramINSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '3', '4', 'Modulverwaltung', '<?php

if( empty( $_GET[\'edit\'])) {

// Einf�gen oder Aktuallisieren von Modulen
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_moduls", array( "name" => $_POST[\'name\'], "menu" => $_POST[\'menu\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_moduls", array( "name" => $_POST[\'name\'], "menu" => $_POST[\'menu\'] ), $_GET[\'update\'] );

// Laden der Liste von Men�punkten 
 $menus = $db->get_assoc( $prefix."admin_menu", 1, "name" );
 $menus[0] = "Inaktiv";

// Formular zum einf�gen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Modul erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_moduls", $_GET[\'settings\'] );
   cbox_auf( \'Modul bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Modulname\', $settings[\'name\'], \'text\' );
 $form->add( \'menu\', \'Menügruppe\', $settings[\'menu\'], \'select\', $menus );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste Aktiver Module
 cbox_auf( "Aktive Module" );

 $captions = array( "id" => "ID", "name" => "Name", "menu_name" => "Menü", "autor" => "Autor" );
 $moduls = $db->fetch_query( "SELECT mds.*, mnu.name menu_name FROM ".$prefix."admin_moduls mds
                              LEFT JOIN ".$prefix."admin_menu mnu ON (mds.menu = mnu.id)
                              WHERE mds.menu > 0 ORDER BY id ASC" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $moduls, "100%" );

 cbox_zu();

// Liste inaktiver Module
 cbox_auf( "Inaktive Module" );

 $moduls = $db->fetch_query( "SELECT mds.*, mnu.name menu_name FROM ".$prefix."admin_moduls mds
                              LEFT JOIN ".$prefix."admin_menu mnu ON (mds.menu = mnu.id)
                              WHERE mds.menu <= 0 ORDER BY id ASC" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $moduls, "100%" );

 cbox_zu();

} else {

// Bearbeiten von Modulinhalt
 if( $edit_modul = $db->get( $prefix."admin_moduls", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von Modulinhalt
     if( isset( $_POST[\'modul_source\'] )) {
       $db->id_update( $prefix."admin_moduls", array( "content" => $_POST[\'modul_source\'] ), $edit_modul[\'id\'] );
       $edit_modul[\'content\'] = stripslashes( $_POST[\'modul_source\'] );
     }

   // �ffnen der Bearbeiten Box
     cbox_auf( "Modul bearbeiten: ".$edit_modul[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_modul[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'modul_source\', $edit_modul[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim öffnen" );

}

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '10', '4', 'Scriptverwaltung', '<?php

if( !empty( $_GET[\'script\'] )) {

// Bearbeiten von Scriptinhalt
 if( $edit_script = $db->get( $prefix."admin_scripts", "id = \'$_GET[script]\'", 1 )) {

    // Aktuallisieren von Scriptinhalt
     if( isset( $_POST[\'script_source\'] )) {
       $db->id_update( $prefix."admin_scripts", array( "content" => $_POST[\'script_source\'] ), $edit_script[\'id\'] );
       $edit_script[\'content\'] = stripslashes( $_POST[\'script_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Script bearbeiten: ".$edit_script[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&script=\'.$edit_script[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'script_source\', $edit_script[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Script wurde nicht gefunden!", "Fehler beim öffnen" );

} elseif( !empty( $_GET[\'editor\'] )) {


// Bearbeiten von Scriptinhalt
 if( $edit_script = $db->get( $prefix."admin_scripts", "id = \'$_GET[editor]\'", 1 )) {

    // Aktuallisieren von Scriptinhalt
     if( isset( $_POST[\'script_source\'] )) {
       $db->id_update( $prefix."admin_scripts", array( "editor" => $_POST[\'script_source\'] ), $edit_script[\'id\'] );
       $edit_script[\'editor\'] = stripslashes( $_POST[\'script_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Script bearbeiten: ".$edit_script[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&editor=\'.$edit_script[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'script_source\', $edit_script[\'editor\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Script wurde nicht gefunden!", "Fehler beim öffnen" );

} else {

// Einfügen oder Aktuallisieren von Scripts
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_scripts", array( "name" => $_POST[\'name\'], "tables" => $_POST[\'tables\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_scripts", array( "name" => $_POST[\'name\'], "tables" => $_POST[\'tables\'] ), $_GET[\'update\'] );

// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Script erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_scripts", $_GET[\'settings\'] );
   cbox_auf( \'Scripts bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Scriptname\', $settings[\'name\'], \'text\' );
 $form->add( \'tables\', \'Tabellen\', $settings[\'tables\'], \'text\' );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste aller Scripts
 cbox_auf( "Scriptliste" );

 $scripts  = $db->get( $prefix."admin_scripts" );
 $captions = array( "id" => "ID", "name" => "Name", "autor" => "Autor" );

 $liste = new liste( $captions );
 $liste->addop( "[S]", MODUL_SELF."&script=", false, "Script bearbeiten" );
 $liste->addop( "[E]", MODUL_SELF."&editor=", false, "Editor bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $scripts, "100%" );

 cbox_zu();

}

?>', 'Master IV' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '17', '4', 'Menü Verwaltung', '<?php
// modul bearbeiten und erstellen
  unset( $_POST[\'id\'] );
  if ($_POST["name"] != "")
    if (!empty($_GET["edit"])) {
       $db->update( $prefix."admin_menu", $_POST, "id = $_GET[edit]" );
       msgbox( \'Menüpunk erfolgreich editiert!\', \'Menüpunk editiert\' );
    }else {
      $db->insert( $prefix."admin_menu", $_POST );
      msgbox( \'Menüpunk erfolgreich hinzugefügt!\', \'Menüpunk hinzugefügt\' );
    }

//Menu löschen
   if (isset($_GET["del"])) {
     $db->id_del( $prefix."admin_menu", $_GET[\'del\'] );
    msgbox( \'Menüpunk erfolgreich gelöscht!\', \'Menüpunk gelöscht\' );
   }

// Daten zum Bearbeiten laden
  if( $reihe = $db->get( $prefix."admin_menu", "id = \'$_GET[edit]\'", 1 ) ) {
    cbox_auf( "Menüpunkt bearbeiten" );
    define( "BACKBUTTON", MODUL_SELF );    
  } else cbox_auf( "Menüpunkt erstellen" );

// Formular ausgeben
  $form = new form( MODUL_SELF."&edit=$_GET[edit]" );
  $form->add( "name", "Name", $reihe[\'name\'], "text" );
  $form->write( "Speichern" );
  cbox_zu();

//Ausgabe
cbox_auf( "Menüpunkte" );
  $captions = array( "id" => "ID", "name" => "Menü Gruppen" );
  $groups = $db->get( $prefix."admin_menu", 1, -1, "id ASC" );
  $liste = new liste( $captions );
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Menüpunkt bearbeiten" );
  $liste->write( $groups, "100%" );

  cbox_zu();
?>', 'Sunny' );
INSERT INTO `{P}admin_moduls` ( `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '18', '4', 'Dateiverwaltung', '<?php

if( empty( $_GET[\'edit\'])) {

// Einfügen oder Aktuallisieren von Dateien
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_files", array( "name" => $_POST[\'name\'], "flag_auto_admin" => (int) $_POST[\'flag_auto_admin\'], "flag_auto_index" => (int) $_POST[\'flag_auto_index\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_files", array( "name" => $_POST[\'name\'], "flag_auto_admin" => (int) $_POST[\'flag_auto_admin\'], "flag_auto_index" => (int) $_POST[\'flag_auto_index\'] ), $_GET[\'update\'] );


// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Datei erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_files", $_GET[\'settings\'] );
   cbox_auf( \'Datei bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Dateinamename\', $settings[\'name\'], \'text\' );
 $form->add( \'flag_auto_admin\', \'Admin einbinden\', $settings[\'flag_auto_admin\'], \'checkbox\' );
 $form->add( \'flag_auto_index\', \'Index einbinden\', $settings[\'flag_auto_index\'], \'checkbox\' );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste Aktiver Dateien
 cbox_auf( "Dateiliste" );

 $captions = array( "id" => "ID", "name" => "Name", "flag_auto_admin" => "Admin", "flag_auto_index" => "index", "autor" => "Autor" );
 $files = $db->get( $prefix."admin_files" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $files, "100%" );

 cbox_zu();

} else {

// Bearbeiten von Modulinhalt
 if( $edit_file = $db->get( $prefix."admin_files", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von odulinhalt
     if( isset( $_POST[\'file_source\'] )) {
       $db->id_update( $prefix."admin_files", array( "content" => $_POST[\'file_source\'] ), $edit_file[\'id\'] );
       $edit_file[\'content\'] = stripslashes( $_POST[\'file_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Datei bearbeiten: ".$edit_file[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_file[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'file_source\', $edit_file[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim Öffnen" );

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '3', '3', '4', 'Modulverwaltung', '<?php

if( empty( $_GET[\'edit\'])) {

// Einf�gen oder Aktuallisieren von Modulen
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_moduls", array( "name" => $_POST[\'name\'], "menu" => $_POST[\'menu\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_moduls", array( "name" => $_POST[\'name\'], "menu" => $_POST[\'menu\'] ), $_GET[\'update\'] );

// Laden der Liste von Men�punkten 
 $menus = $db->get_assoc( $prefix."admin_menu", 1, "name" );
 $menus[0] = "Inaktiv";

// Formular zum einf�gen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Modul erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_moduls", $_GET[\'settings\'] );
   cbox_auf( \'Modul bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Modulname\', $settings[\'name\'], \'text\' );
 $form->add( \'menu\', \'Menügruppe\', $settings[\'menu\'], \'select\', $menus );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste Aktiver Module
 cbox_auf( "Aktive Module" );

 $captions = array( "id" => "ID", "name" => "Name", "menu_name" => "Menü", "autor" => "Autor" );
 $moduls = $db->fetch_query( "SELECT mds.*, mnu.name menu_name FROM ".$prefix."admin_moduls mds
                              LEFT JOIN ".$prefix."admin_menu mnu ON (mds.menu = mnu.id)
                              WHERE mds.menu > 0 ORDER BY id ASC" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $moduls, "100%" );

 cbox_zu();

// Liste inaktiver Module
 cbox_auf( "Inaktive Module" );

 $moduls = $db->fetch_query( "SELECT mds.*, mnu.name menu_name FROM ".$prefix."admin_moduls mds
                              LEFT JOIN ".$prefix."admin_menu mnu ON (mds.menu = mnu.id)
                              WHERE mds.menu <= 0 ORDER BY id ASC" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $moduls, "100%" );

 cbox_zu();

} else {

// Bearbeiten von Modulinhalt
 if( $edit_modul = $db->get( $prefix."admin_moduls", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von Modulinhalt
     if( isset( $_POST[\'modul_source\'] )) {
       $db->id_update( $prefix."admin_moduls", array( "content" => $_POST[\'modul_source\'] ), $edit_modul[\'id\'] );
       $edit_modul[\'content\'] = stripslashes( $_POST[\'modul_source\'] );
     }

   // �ffnen der Bearbeiten Box
     cbox_auf( "Modul bearbeiten: ".$edit_modul[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_modul[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'modul_source\', $edit_modul[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim öffnen" );

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '7', '7', '2', 'Panelgroups', '<?php

 // Einfügen und Bearbeiten
  if( !empty( $_POST[\'name\'] ) && !empty( $_POST[\'replace\'] ))
    if( !empty( $_GET[\'update\'] )) 
      $db->id_update( $prefix."content_groups", array( "name" => $_POST[\'name\'], "replace" => $_POST[\'replace\'] ), $_GET[\'update\'] );
      else $db->insert( $prefix."content_groups", array( "name" => $_POST[\'name\'], "replace" => $_POST[\'replace\'] ));

 // Panelgroup Löschen
  if( !empty( $_GET[\'del\'] )) {
    if( empty( $_POST[\'replace\'] )) {
      $form = new form( MODUL_SELF."&del=".$_GET[\'del\'] );
      $replace[-1] = "Panels löschen";
      foreach( $groups = $db->get( $prefix."content_groups" ) as $g )
      if( $g[\'id\'] != $_GET[\'del\'] ) $replace[$g[\'id\']] = $g[\'name\'];
	  
      cbox_auf( "Panelgroup löschen" );
      $form->add( \'replace\', \'Neue Panelgroup\', 0, "select", $replace );
      $form->write( \'Löschen\' );
      cbox_zu();
    } elseif( $_POST[\'replace\'] != $_GET[\'del\'] ) {
      if( $_POST[\'replace\'] == -1 ) {
        $scripts = $db->get_assoc( $prefix."content_scripts", 1, "tables" );
        $panels = $db->get( $prefix."content_panels", "`group` = \'$_GET[del]\'" );
        foreach( $panels as $pan ) 
        foreach( explode( ",", $scripts[$panel[\'script\']] ) as $table )
          if( !empty( $table ))
            $db->del( $prefix.trim( $table ), "panel = \'$pan[id]\'" );
            $db->del( $prefix."content_panels", "`group` = \'$_GET[del]\'" );
	  } else $db->update( $prefix."content_panels", array( "group" => $_POST[\'replace\'] ), "`group` = \'$_GET[del]\'" );
        $db->id_del( $prefix."content_groups", $_GET[\'del\'] );
        msgbox( \'Die Panelgroup wurde erfolgreich gelöscht.\', \'Panelgroup gelöscht\' );
    }
  } else {
   // Formular zum bearbeiten und erstellen
    if( !empty( $_GET[\'edit\'] )) {
      $edit = $db->id_get( $prefix."content_groups", $_GET[\'edit\'] );
      cbox_auf( "Panelgroup bearbeiten" );
      $form = new form( MODUL_SELF."&update=".$edit[\'id\'] );
      define( "BACKBUTTON", MODUL_SELF );
    } else {
      cbox_auf( "Panelgroup erstellen" );
      $form = new form( MODUL_SELF );
    }
	
    $form->add( "name", "Name", $edit[\'name\'] );
    $form->add( "replace", "Platzhalter", $edit[\'replace\'] );
    $form->write( "Speichern" );
    cbox_zu();
  }

 // Liste der Panelgroups
  cbox_auf( "Panelgroups" );
  
  $captions = array( "name" => "Name", "replace" => "Platzhalter" );
  $groups = $db->get( $prefix."content_groups" );
  
  $liste = new liste( $captions );        
  $liste->addop( "[X]", MODUL_SELF."&del=", false, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
  $liste->write( $groups, "100%" );
  
  cbox_zu();


?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '8', '8', '3', 'Userverwaltung', '<?php

// Schützen der Get und Post Variablen sowie includen der System-Permissions
  strip_array_tags( $_POST );
  strip_array_tags( $_GET  );

// Funktion zu Zugriffsprüfung
function user_getops( $row, $opts ) {
  global $userdata;

  if( $userdata[\'rank\'] > $row[\'rank\'] ) return getops( $row, $opts );
  else return "&nbsp;";
}

// Assioziatives Array mit allen Gruppen erzeugen
  $gps = $db->get_assoc( $prefix."user_groups", 1, "name" );
  $gps[0] = "Gesperrt";
  $gps[9] = "Systemadministrator";
  ksort( $gps );

// User Löschen
  if( !empty( $_GET[\'del\'] ))
    if( $deluser = $db->id_get( $prefix."user_data", $_GET[\'del\'] ))
      if( $deluser[\'rank\'] < $userdata[\'rank\'] ) {
        $db->id_del( $prefix."user_data", $_GET[\'del\'] );
      }

// User Anlegen und Bearbeiten
if( !empty( $_POST[\'name\'] ) && !empty( $_POST[\'email\'] )) {  
  if( $db->get( $prefix."user_data", "name = \'$_POST[name]\' AND id != \'$_POST[update]\'", 1 ))
    msgbox( \'Username bereits vergeben!\', \'Fehler bei der Usererstellung\' );
  elseif( check_mail( $_POST[\'email\'] ))
    msgbox( \'Bitte geben sie eine gültige Mail-Adresse an!\', \'Fehler bei der Userverwaltung\' );
  elseif( !empty( $_POST[\'update\'] )) {
    if( $uu = $db->id_get( $prefix."user_data", $_POST[\'update\'] )) {
      if( empty( $_POST[\'pass\'] )) $_POST[\'pass\'] = $uu[\'pass\'];
      else $_POST[\'pass\'] = md5( $_POST[\'pass\'] );

      $db->update( $prefix."user_data", $_POST, "id = $uu[id] AND rank < ".$userdata[\'rank\'] );
      msgbox( \'User aktuallisiert!\', \'Fehler bei der Userverwaltung\' );
    } else msgbox( \'User nicht gefunden\', \'Fehler bei der Userverwaltung\' );
  } else { 
    $passwort = $_POST[\'pass\'];
    if( empty( $_POST[\'pass\'] )) $passwort = genpw( 10 );
    $_POST[\'pass\'] = md5( $passwort );
    if( $_POST[\'rank\'] >= $userdata[\'rank\'] ) $_POST[\'rank\'] = $userdata[\'rank\'] - 1;

$text = "Willkommen im Team von $options[page_name],
Um ihre Logindaten lauten wie folgt:\\n
Username: $_POST[name] \\n
Userpass: $passwort \\n\\n
Sie können sich mit diesen Daten nun unter:
$options[page_url]/".IV_SELF." einloggen\\n\\n
Bei problemen wenden sie sich bitte an den zuständigen Administrator.\\n\\n
Mit freundlichen Grüßen\\n       $userdata[name]";
    
    smail( $userdata[\'email\'], $userdata[\'name\'], $_POST[\'email\'], $options[\'regsubject\'], $text );
    $db->insert( $prefix."user_data", $_POST );
    msgbox( \'Der User \'.$_POST[\'name\'].\' wurde mit dem Passwort "\'.$passwort.\'" angelegt!\', \'User erfolgreich angelegt!\' );
  }
}

// Verteilbare Gruppen
$agps = array();
foreach( $gps as $i => $g )
  if( $i < $userdata[\'rank\'] )
    $agps[$i] = $g;

// Formular zum erstellen und ändern von Usern   
  $form = new form( MODUL_SELF );

  if( !empty( $_GET[\'edit\'] )) {
    if( $edituser = $db->id_get( $prefix."user_data", $_GET[\'edit\'] )) {
      if( $userdata[\'rank\'] > $edituser[\'rank\'] ) {   
        $back = true;
        cbox_auf( \'User bearbeiten\' );
		define( "BACKBUTTON", MODUL_SELF );
        $form->add( "update", "-", $edituser[\'id\'], "hidden" );
      } else {
        cbox_auf( \'User erstellen\' );
        $edituser = array();
      }
    } else cbox_auf( \'User erstellen\' );
  } else cbox_auf( \'User erstellen\' );

  $form->add( "name", "Username", $edituser[\'name\'] ); 
  $form->add( "email", "E-Mail", $edituser[\'email\'] );
  $form->add( "pass", "Passwort", "", "password" );
  $form->add( "rank", "Gruppe", $edituser[\'rank\'], "select", $agps );

  $form->write( "Speichern" );
  cbox_zu();

// Ausgabe der Userliste
  cbox_auf( \'Userliste</h3>\' );
  $captions = array( "id" => "ID", "name" => "Name", "email" => "E-Mail", "group" => "Gruppe" );

  $users = $db->get( $prefix."user_data", 1, -1, "rank DESC" );
  foreach( $users as $i => $u )
    $users[$i][\'group\'] = $gps[$u[\'rank\']];

  $liste = new liste( $captions );        
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "User bearbeiten" );
  $liste->opfunk = "user_getops";
  $liste->write( $users, "100%" );
  
  cbox_zu();

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '9', '9', '3', 'Gruppenverwaltung', '<script language="javascript">
function rename( url, id, oldname ) {
  var newname = window.prompt( \'Neuer Name:\', oldname );
  if( newname == null ) return false;
  else {
    window.location.href= url+\'&rename=\'+id+\'&name=\'+newname;
    return true;
  }
}
</script><?php

// Schützen der Get und Post Variablen sowie includen der System-Permissions
  strip_array_tags( $_POST );
  strip_array_tags( $_GET  );


// Hilfsfunktion um das Formular zur Gruppenbearbeitung zu generieren
function checklist( $caption, $options, $values, $pre = "" ) {
  echo \'<table align="center"><tr><th style="text-align:center" colspan="4">\'.$caption.\'</th></tr><tr>\'; $i = 0;
  foreach( $options as $p => $option ) {
    if( $i % 2 == 0 && $i != 0 ) echo \'</tr><tr>\'; $i++;
    echo \'<td width="20" align="center"><input type="checkbox" name="reperm[]" value="\'.$pre.$p.\'"\';
    if( strstr( $values, ".$pre$p." )) echo \' checked\';
    echo \'></td><td width="250">\'.$option.\'</td>\';
  } echo \'</tr></table><br>\';
}

// Umbenennen einer Gruppe
if( !empty( $_GET[\'rename\'] ) && !empty( $_GET[\'name\'] )) {
  $gruppe = (int) $_GET[\'rename\']; $query = array( "name" => $_GET[\'name\'] );
  if( $gruppe > 0 && $gruppe < $userdata[\'rank\'] ) $db->id_update( $prefix."user_groups", $query, $gruppe );
  else msgbox( \'Ungültige Gruppe\' );
}

// Funktion zu Zugriffsprüfung
function groups_getops( $row, $opts ) {
  global $userdata, $usergroup;

  if( $userdata[\'rank\'] > $row[\'id\'] ) {
    $code = \'<a href="#" title="Umbenennen" onclick="return rename( \\\'\'.MODUL_SELF.\'\\\', \\\'\'.
             $row[\'id\'].\'\\\', \\\'\'.$row[\'name\'].\'\\\');">[R]</a>
             <a title="Rechte ändern" href="\'.MODUL_SELF.\'&perm=\'.$row[\'id\'].\'">[P]</a>\';
    return $code;
  } else return "&nbsp;";
}

// Rechte ändern
if( !empty( $_GET[\'perm\'] )) {
  $gruppe = (int) $_GET[\'perm\'];
  if( $gruppe <= 0 && $gruppe >= $userdata[\'rank\'])
    msgbox( \'Ungültige Gruppe\' );
  elseif( isset( $_POST[\'update\'] )) {
    $reperm = (is_array( $_POST[\'reperm\'] )) ? ".".implode( ".", $_POST[\'reperm\'] )."." : ".";
    $query = array(  "perms" => $reperm );
    $db->id_update( $prefix."user_groups", $query, $gruppe );
  } else {
    $egroup = $db->id_get( $prefix."user_groups", $gruppe );
	cbox_auf( \'Rechte ändern: \'.htmlspecialchars( $egroup[\'name\'] ));
    echo \'<form action="\'.MODUL_SELF.\'&perm=\'.$egroup[\'id\'].\'" method="post" name="perms">
          <input type="hidden" name="update" value="1">\';

    //checklist( "Allgemeine Rechte", $perms, $egroup[\'perms\'] );
    checklist( "Modul Rechte", $db->get_assoc( $prefix."admin_moduls", 1, "name" ), $egroup[\'perms\'], "M" );
    checklist( "Script Rechte", $db->get_assoc( $prefix."admin_scripts", 1, "name" ), $egroup[\'perms\'], "S" );
    //checklist( "Panel Rechte", $$db->get_assoc( $prefix."panels", "script = x", "name" ), $egroup[\'perms\'], "P" );

    echo \'<p align="center"><input type="submit" value="Speichern">
          <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.MODUL_SELF.\'\\\';"></p></form>\';
		  cbox_zu();
  }
}

// Auflistung der Gruppen
  cbox_auf( \'Gruppenliste\' );
  $captions = array( "id" => "ID", "name" => "Name" );
  $groups = $db->get( $prefix."user_groups", 1, -1, "id DESC" );
  $liste = new liste( $captions );
  $liste->opfunk = "groups_getops";
  $liste->write( $groups, "100%" );
  cbox_zu();

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '10', '10', '4', 'Scriptverwaltung', '<?php

if( !empty( $_GET[\'script\'] )) {

// Bearbeiten von Scriptinhalt
 if( $edit_script = $db->get( $prefix."admin_scripts", "id = \'$_GET[script]\'", 1 )) {

    // Aktuallisieren von Scriptinhalt
     if( isset( $_POST[\'script_source\'] )) {
       $db->id_update( $prefix."admin_scripts", array( "content" => $_POST[\'script_source\'] ), $edit_script[\'id\'] );
       $edit_script[\'content\'] = stripslashes( $_POST[\'script_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Script bearbeiten: ".$edit_script[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&script=\'.$edit_script[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'script_source\', $edit_script[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Script wurde nicht gefunden!", "Fehler beim öffnen" );

} elseif( !empty( $_GET[\'editor\'] )) {


// Bearbeiten von Scriptinhalt
 if( $edit_script = $db->get( $prefix."admin_scripts", "id = \'$_GET[editor]\'", 1 )) {

    // Aktuallisieren von Scriptinhalt
     if( isset( $_POST[\'script_source\'] )) {
       $db->id_update( $prefix."admin_scripts", array( "editor" => $_POST[\'script_source\'] ), $edit_script[\'id\'] );
       $edit_script[\'editor\'] = stripslashes( $_POST[\'script_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Script bearbeiten: ".$edit_script[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&editor=\'.$edit_script[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'script_source\', $edit_script[\'editor\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Script wurde nicht gefunden!", "Fehler beim öffnen" );

} else {

// Einfügen oder Aktuallisieren von Scripts
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_scripts", array( "name" => $_POST[\'name\'], "tables" => $_POST[\'tables\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_scripts", array( "name" => $_POST[\'name\'], "tables" => $_POST[\'tables\'] ), $_GET[\'update\'] );

// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Script erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_scripts", $_GET[\'settings\'] );
   cbox_auf( \'Scripts bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Scriptname\', $settings[\'name\'], \'text\' );
 $form->add( \'tables\', \'Tabellen\', $settings[\'tables\'], \'text\' );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste aller Scripts
 cbox_auf( "Scriptliste" );

 $scripts  = $db->get( $prefix."admin_scripts" );
 $captions = array( "id" => "ID", "name" => "Name", "autor" => "Autor" );

 $liste = new liste( $captions );
 $liste->addop( "[S]", MODUL_SELF."&script=", false, "Script bearbeiten" );
 $liste->addop( "[E]", MODUL_SELF."&editor=", false, "Editor bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $scripts, "100%" );

 cbox_zu();

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '11', '11', '2', 'Content Verwaltung', '<script language="javascript" type="text/javascript">
  function dellayer( id ) {
    if( window.confirm( "Wollen sie diesen Layer einschließlich aller untergeordneten Layer und Panels unwiederbringlich löschen?" ))
	window.location.href = \'<?php echo MODUL_SELF ?>&dellayer=\'+id;
  }
</script><?php

  $layer_temptype = 0;
  $panel_temptype = 1;

  function rekcheck( $layer ) {
    global $prefix, $userdata, $db;
	
	$layer = $db->id_get( $prefix."content_layer", $layer );
	if( $layer[\'rank\'] > $userdata[\'rank\'] ) return false;
	else {
	  $delable = true;
	  $subs = $db->get( $prefix."content_layer", "parent = \'$layer[id]\'" );
	  foreach( $subs as $sub ) if( !rekcheck( $sub[\'id\'] )) $delable = false;
	  return $delable;
	}
  }
  
  function rekdel( $layer ) {
    global $prefix, $db;
    $scripts = $db->get_assoc( $prefix."content_scripts", 1, "tables" );
	
    $subs = $db->get( $prefix."content_layer", "parent = \'$layer\'" );
    foreach( $subs as $sub ) rekdel( $sub[\'id\'] );
	
    $panels = $db->get( $prefix."content_panels", "layer = \'$layer\'" );
    foreach( $panels as $pan ) 
      foreach( explode( ",", $scripts[$panel[\'script\']] ) as $table )
        if( !empty( $table ))
          $db->del( $prefix.trim( $table ), "panel = \'$pan[id]\'" );
	  
    $db->del( $prefix."content_panels", "layer = \'$layer\'" );
    $db->id_del( $prefix."content_layer", $layer );
  }
  
  function check_ref( $ref, $layid ) {
    global $prefix, $db;
    if( $ref == 0 ) return true;
    elseif( $ref == $layid ) return false;
    else {
      $res = $db->id_get( $prefix."content_layer", $ref );
      return check_ref( $res[\'parent\'], $layid );
    }
  }

// Layer löschen
  if( !empty( $_GET[\'dellayer\'] )) 
    if( $dlayer = $db->id_get( $prefix."content_layer", $_GET[\'dellayer\'] ))
	  if( rekcheck( $dlayer[\'id\'] )) rekdel( $dlayer[\'id\'] );
	  else msgbox( \'Fehler beim löschen des Layers: Sie besitzen nicht genügend Rechte um diesen Layer zu löschen!\', \'Fehler beim Löschen!\' );

// Layer bearbeiten
  if( !empty( $_GET[\'layer\'] ) && !empty( $_POST[\'name\'] ) && ( $_POST[\'rank\'] <= $userdata[\'rank\'] )) 
    if( check_ref( (int) $_POST[\'parent\'], (int) $_GET[layer] ) ) {
      $query = array( "status" => $_POST[\'status\'], "name" => $_POST[\'name\'], "template" => $_POST[\'template\'], "rank" => $_POST[\'rank\'], "parent" => $_POST[\'parent\'] );
      $db->update( $prefix."content_layer", $query, "id = \'$_GET[layer]\' AND rank <= \'$userdata[rank]\'" );
    } else msgbox( \'Sie haben eine ungültige Referenz angegeben!\', \'Fehler beim bearbeiten!\' );


// Layer laden
  if( !empty( $_GET[\'layer\'] )) {
    $panel = false;
    $layer = $db->id_get( $prefix."content_layer", $_GET[\'layer\'] );
  } elseif( !empty( $_GET[\'panel\'] )) {
    $panel = $db->id_get( $prefix."content_panels",  $_GET[\'panel\'] );
	$layer = $db->id_get( $prefix."content_layer", $panel[\'layer\'] );
  } else { 
    $panel = false;
    $layer = false;
  }
  
// Rechte prüfen  
  if( $layer[\'rank\'] > $userdata[\'rank\'] ) {
    msgbox( \'Sie haben auf diesen Layer keinen Zugriff\', \'Unberechtigter Zugriff\' );
    $db->id_update( $prefix."user_data", array( "sessid" => "" ), $userdata[\'id\'] );
    $db->close(); page_footer(); exit();
  }  
  
// Startseite Setzen
  if( isset( $_GET[\'default\'] ) && $layer ) set_short_var( "defpage" , 0, $layer[\'id\'] );
  
  if( $panel && isset( $_GET[\'content\'] )) {

  if( !strstr( $usergroup[\'perms\'], ".S$panel[script]." ) && $userdata[\'rank\'] != 9 )  {
    msgbox( \'Sie haben auf diesen Layer keinen Zugriff\', \'Unberechtigter Zugriff\' );
    $db->id_update( $prefix."user_data", array( "sessid" => "" ), $userdata[\'id\'] );
    $db->close(); page_footer(); exit();
  }  

  define( "EDITOR_SELF", MODUL_SELF."&content=1&panel=".$panel[\'id\'] );
  define( "LAYER_SELF", MODUL_SELF."&layer=".$layer[\'id\'] );

  if( $script = $db->id_get( $prefix."admin_scripts", $panel[\'script\'] )) {
    cbox_auf( "Panel bearbeiten: ".htmlspecialchars( $panel[\'name\'] ) ); 
    eval( " ?>$script[editor]<?php " );
    cbox_zu();
  } else msgbox( \'Script nicht gefunden!?!\' );

} else {
  
// Panel Löschen  
  if( !empty( $_GET[\'delpanel\'] )) {
    $del = $db->id_get( $prefix."content_panels", $_GET[\'delpanel\'] );
    if( $del[\'layer\'] == $layer[\'id\'] || ( !$layer && $del[\'layer\'] == 0 )) 
      if( $script = $db->id_get( $prefix."admin_scripts", $del[\'script\'] )) {
	    foreach( explode( ",", $script[\'tables\'] ) as $table )
	      if( !empty( $table ))
	        $db->del( $prefix.trim( $table ), "panel = \'$del[id]\'" );
	    $db->id_del( $prefix."content_panels", $del[\'id\'] );
      }
  }
  
// Panel bearbeiten + erstellen
  if( !empty( $_POST[\'pname\'] ) && !empty( $_POST[\'group\'] )) 
  if( $db->id_get( $prefix."content_groups", $_POST[\'group\'] ))  {
	$_POST[\'name\'] = $_POST[\'pname\'];
	$_POST[\'template\'] = $_POST[\'ptemplate\'];
	unset( $_POST[\'id\'] ); $_POST[\'layer\'] = $layer[\'id\'];
	
    if( $panel ) {
	  $db->update( $prefix."content_panels", $_POST, "id = \'$panel[id]\' AND layer = \'$layer[id]\'" );
	  $panel = $db->id_get( $prefix."content_panels", $panel[\'id\'] );
	} elseif( !empty( $_POST[\'script\'] )) {
	  $_POST[\'script\'] = (int) $_POST[\'script\'];
	  if( strstr( $usergroup[\'perms\'], ".S$_POST[script]." ) || $userdata[\'rank\'] == 9 ) 
		$db->insert( $prefix."content_panels", $_POST );
	} 
  }
  
// Parent laden
  if( !empty( $layer[\'parent\'] )) $parent = $db->id_get( $prefix."content_layer", $layer[\'parent\'] );

// Neuen Layer anlegen
  if( isset( $_GET[\'addlayer\'] )) {
    $parent = $db->id_get( $prefix."content_layer", $_GET[\'addlayer\'] );
	
	$layer = array();
	$layer[\'name\'] = "neuer Layer";
	$layer[\'parent\'] = $parent[\'id\'];
	$layer[\'rank\'] = $parent[\'rank\'];
	
	$db->insert( $prefix."content_layer", $layer );
	$layer[\'id\'] = $db->id();
  }

// Seite in zwei spalten teilen
  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr><td width="350" valign="top">\';
  
// Layerliste
  $spage = get_short_var( "defpage" , 0 );

  function layertree( $parent, $depth ) {
    global $userdata, $db, $prefix, $layer, $spage;
	
	$layers = $db->get( $prefix."content_layer", "parent = \'$parent\'" );
	foreach( $layers as $l) {
	  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr>\';
	  
	  echo str_repeat( \'<td width="20" height="20"><img src="images/icons/tree1.png" alt ="|" boder="0"></td>\', $depth );
	  echo \'<td width="20" height="20"><img src="images/icons/tree2.png" alt="-" boder="0"></td><td width="20" height="20"><img src="images/icons/\'; 
	  
	  if( $l[\'id\'] == $layer[\'id\'] ) 
	    if( $l[\'status\'] ) echo \'ia\';
		else echo \'a\';
	  elseif( $l[\'status\'] ) echo \'i\';
	  
	  echo \'layer.gif" alt ="l" boder="0"></td>\';
	  
	  if( $l[\'rank\'] > $userdata[\'rank\'] ) echo \'<td style="font-size: 10px">&nbsp; \'.htmlspecialchars( $l[\'name\'] );
	  else echo \'<td style="font-size: 10px">&nbsp; <a href="\'.MODUL_SELF.\'&layer=\'.$l[\'id\'].\'">\'.htmlspecialchars( $l[\'name\'] ).\'</a>\';
	  if( $l[\'id\'] == $spage ) echo \' (s)\'; echo \'<td></tr></table>\';
	  layertree( $l[\'id\'], $depth+1 );
    }
  }
  
  cbox_auf( \'Layerliste\' );
  echo \'<table width="100%" cellspacing="0" cellpadding="0"><tr>\';
  if( !$layer ) echo \'<td width="20" height="20"><img src="images/icons/alayer.gif" alt ="l" boder="0"></td>\';
  else echo \'<td width="20" height="20"><img src="images/icons/layer.gif" alt ="l" boder="0"></td>\';
  echo \'<td style="font-size: 10px">&nbsp; <a href="\'.MODUL_SELF.\'">IV Content Management System</a><td></tr></table>\';
  
  layertree( 0, 0 );
  
  cbox_zu();
  
  cbox_auf( \'Panelliste\' ); $c = 0;
  $captions = array( "name" => "Name" );
  $panels = $db->get( $prefix."content_panels", "layer = \'$layer[id]\'" );
  if( !count( $panels )) echo \'<p align="center">Keine Panels vorhanden.</p>\';
  else { 
  
    $liste = new liste( $captions );        
    $liste->addop( "[X]", MODUL_SELF."&layer=".$layer[\'id\']."&delpanel=", true, "Löschen" );
    $liste->addop( "[E]", MODUL_SELF."&panel=", false, "Panel bearbeiten" );
    $liste->addop( "[I]", MODUL_SELF."&content=1&panel=", false, "Inhalt bearbeiten" );
    $liste->write( $panels, "100%" );
  
  } cbox_zu();
  
// Zweite Spalte
  echo \'</td><td width="15">&nbsp;</td><td valign="top">\';
  
// Layereinstellung
  if( $layer ) {
    cbox_auf( \'Layer bearbeiten\' );  
    $form = new form( MODUL_SELF."&layer=".$layer[\'id\'] );
	
// Assioziatives Array mit allen Gruppen erzeugen
    $gps = $db->get_assoc( $prefix."user_groups", "id < \'$userdata[rank]\'", "name" );
    if( $userdata[\'rank\'] == 9 ) $gps[9] = "Systemadministrator"; ksort( $gps );
    $layers = $db->get_assoc( $prefix."content_layer", "id != \'$layer[id]\' AND parent != \'$layer[id]\'", "name" );
    $layers[0] = "IV CMS"; 

    $form->add( "name", "Name", $layer[\'name\'] ); 
    $form->add( "template", "Template", $layer[\'template\'], "select", array_merge( array( "Kein Template" ) , $db->get_assoc( $prefix."content_templates", "`type` = \'$layer_temptype\'", "name" ))); 
    $form->add( "rank", "Mindestgruppe", $layer[\'rank\'], "select", $gps ); 
    $form->add( "status", "Status", $layer[\'status\'], "select", array( "Aufrufbar", "Deaktiviert" ));
    $form->add( "parent", "Parent", $layer[\'parent\'], "select", $layers ); 

    $form->write( "Speichern", 25 );
    cbox_zu();
  }
  
  cbox_auf( \'Optionen\' );  
    echo \'<p align="center"><input type="button" value="Layer hinzufügen" onclick="window.location.href = \\\'\'.MODUL_SELF."&addlayer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
    if( $layer ) {
      echo \'<p align="center"><input type="button" value="Layer entfernen" onclick="dellayer( \'.$layer[\'id\'].\' );" style="width: 90%"></p>\';
      echo \'<p align="center"><input type="button" value="Als Startseite verwenden" onclick="window.location.href = \\\'\'.MODUL_SELF."&default=1&layer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
      echo \'<p align="center"><input type="button" value="Unterpunkte Ein/Ausblenden" onclick="window.location.href = \\\'\'.MODUL_SELF."&hide=1&layer=".$layer[\'id\'].\'\\\';" style="width: 90%"></p>\';
    }
  cbox_zu();
  
  
  if( $panel ) {
    cbox_auf( "Panel bearbeiten" );
	$form = new form( MODUL_SELF."&panel=".$panel[\'id\'] );
	define( "BACKBUTTON", MODUL_SELF."&layer=".$layer[\'id\'] );
  } else {
    cbox_auf( "Panel erstellen" );
    $form = new form( MODUL_SELF."&layer=".$layer[\'id\'] );
  }
  
  $form->add( "pname", "Name", $panel[\'name\'] ); 
  $form->add( "group", "Panelgroup", $panel[\'group\'], "select", $db->get_assoc( $prefix."content_groups", 1, "name" )); 
  $form->add( "ptemplate", "Template", $panel[\'template\'], "select", array_merge( array( 0 => "Kein Template" ), $db->get_assoc( $prefix."content_templates", "`type` = \'$panel_temptype\'", "name" ))); 
  
  if( !$panel ) {
    foreach( $db->get_assoc( $prefix."admin_scripts", 1, "name" ) as $i => $n )
	if( strstr( $usergroup[\'perms\'], ".S$i." ) || $userdata[\'rank\'] == 9 ) $scripts[$i] = $n;
    $form->add( "script", "Script", 0, "select", $scripts );  
  } 
  
  $form->add( "status", "Status", $panel[\'status\'], "select", array( "Aktiv", "Versteckt" )); 
  $form->add( "prio", "Priorität", $panel[\'prio\'] ); 
  $form->write( "Speichern", 25 );

  cbox_zu();

  
// ende der seite
  echo \'</td></tr></table>\';

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '12', '12', '3', 'Optionen', '<?php

  $layertype = 0;
  $othertype = 3;

  if( isset( $_POST ) && isset( $_GET[\'update\'] ))
    foreach( $_POST as $key => $wert )
      $db->query( "UPDATE ".$prefix."data_options SET value = \'$wert\' WHERE name = \'$key\'" );
	  
  if( !empty( $_POST[\'deftemplate\'] )) set_short_var( "deftemplate", 0, $_POST[\'deftemplate\'] );
  if( !empty( $_POST[\'errortemplate\'] )) set_short_var( "errortemplate", 0, $_POST[\'errortemplate\'] );
  if( !empty( $_POST[\'newsscript\'] )) set_short_var( "newsscript", 0, $_POST[\'newsscript\'] );
  
  cbox_auf( $mod[\'name\'] );
  $form = new form( MODUL_SELF."&update" );
  foreach( $db->get( $prefix."data_options" ) as $option )
  $form->add( $option[\'name\'], $option[\'caption\'], $option[\'value\'] );
  
  $form->hr();
  $form->add( "deftemplate", "Hauptdesign", get_short_var( "deftemplate", 0 ), "select", $db->get_assoc( $prefix."content_templates", "`type` = \'$layertype\'", "name" ));
  $form->add( "errortemplate", "Wartungsdesign", get_short_var( "errortemplate", 0 ), "select", $db->get_assoc( $prefix."content_templates", "`type` = \'$othertype\'", "name" ));
  $form->add( "newsscript", "News Script", get_short_var( "newsscript", 0 ), "select", $db->get_assoc( $prefix."admin_scripts", 1, "name" ));
  
  $form->write( "Speichern", 40 );
  cbox_zu();

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '13', '13', '2', 'Templates', '<?php

if( empty( $_GET[\'edit\'])) {

// Einfügen oder Aktuallisieren von Templates
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."content_templates", array( "name" => $_POST[\'name\'], "type" => $_POST[\'type\'] ));
     else $db->id_update( $prefix."content_templates", array( "name" => $_POST[\'name\'], "type" => $_POST[\'type\'] ), $_GET[\'update\'] );

// TemplateTypen 
 $types = array( "Layer-Template", "Panel-Template", "News-Templates", "Sonstige Templates" );

// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Template erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."content_templates", $_GET[\'settings\'] );
   cbox_auf( \'Teplate bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Templatename\', $settings[\'name\'], \'text\' );
 $form->add( \'type\', \'Templatetype\', $settings[\'type\'], \'select\', $types );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste der Templates
 $captions = array( "id" => "ID", "name" => "Name" );
 foreach( $types as $key => $type ) {
   cbox_auf( $type );

   $templates = $db->get( $prefix."content_templates", "`type` = \'$key\'" );

   $liste = new liste( $captions );
   $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
   $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
   $liste->write( $templates, "100%" );

   cbox_zu();
 }

} else {

// Bearbeiten von Templateinhalt
 if( $edit_template = $db->get( $prefix."content_templates", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von Templateinhalt
     if( isset( $_POST[\'template_source\'] )) {
       $db->id_update( $prefix."content_templates", array( "content" => $_POST[\'template_source\'] ), $edit_template[\'id\'] );
       $edit_template[\'content\'] = stripslashes( $_POST[\'template_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Template bearbeiten: ".$edit_template[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_template[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'template_source\', $edit_template[\'content\'], $userdata[\'option_editor\'], "html" );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim öffnen" );

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '14', '14', '3', 'Wartungsmodus', '<?php

  if( isset( $_POST[\'wartung\'] )) {
    set_short_var( "wartung", 0, $_POST[\'wartung\'] );
    set_text_var( "wreason", 0, $_POST[\'reason\'] );
  }

  cbox_auf( $mod[\'name\'] );
  $form = new form( MODUL_SELF );
  $form->add( "wartung", "Wartungsmodus", get_short_var( "wartung", 0 ), "select", array( "Ausgeschaltet", "Eingeschaltet"  )); 
  $form->add( "reason", "Begründung", get_text_var( "wreason", 0 ), "textarea", 10 );
  $form->write( "Speichern" );
  cbox_zu();

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '15', '15', '1', 'Userdaten Ändern', '<?php

  if( !empty( $_POST[\'oldpass\'] ))
    if( $userdata[\'pass\'] == md5( $_POST[\'oldpass\'] )) {
	  if( !empty( $_POST[\'newpass\'] ) && !empty( $_POST[\'repass\'] )) 
        if( $_POST[\'newpass\'] == $_POST[\'repass\'] ) {
          $db->query( "UPDATE ".$prefix."user_data SET pass = MD5( \'$_POST[newpass]\' ) WHERE id = \'$userdata[id]\'" );
          msgbox( "Passwort wurde erfolgreich geändert.", "Passwortverwaltung" );
        } else msgbox( "Passwort und Wiederholung stimmen nicht überein.", "Passwortverwaltung" );
	  if( !empty( $_POST[\'email\'] ) && $_POST[\'email\'] != $userdata[\'email\'] ) 
	    if( !check_mail( $_POST[\'email\'] )) {
		  $db->query( "UPDATE ".$prefix."user_data SET email = \'$_POST[email]\' WHERE id = \'$userdata[id]\'" );
          msgbox( "E-Mail Adresse wurde erfolgreich geändert.", "E-Mail Adresse ändern" );
		} else msgbox( "Bitte geben sie eine Gültige E-Mail Adresse an.", "E-Mail Adresse ändern" );
    } else msgbox( "Das eingegebene Passwort ist nicht korrekt.", "Passwortverwaltung" );

  if( isset( $_POST[\'option_editor\'] ) && isset( $_POST[\'option_wysiwyg\'] )) {
    $db->id_update( $prefix."user_data", array( \'option_editor\' => $_POST[\'option_editor\'], \'option_wysiwyg\' => $_POST[\'option_wysiwyg\'] ), $userdata[\'id\'] );
    $userdata[\'option_editor\'] = $_POST[\'option_editor\'];
    $userdata[\'option_wysiwyg\'] = $_POST[\'option_wysiwyg\'];
  }

  cbox_auf( \'Userdaten ändern\' );

  $form = new form( MODUL_SELF );                            
  $form->add( "oldpass", "Altes Passwort", "", "password" );
  $form->add( "email", "E-Mail Adresse", $userdata[\'email\'] );
  $form->add( "newpass", "Neues Passwort", "", "password" );
  $form->add( "repass", "Passwort Wiederholung", "", "password" );
  $form->write( );

  cbox_zu();

  cbox_auf( \'Persönliche Einstellungen\' );
  $editors = array( "Textarea", "Codepress", "Helene (noch nicht implementiert)", "EditArea" );
  $wysiwyg = array( "Textarea", "openWYSIWYG" );
  
  $form = new form( MODUL_SELF );                            
  $form->add( "option_editor", "Quelltext Editor", $userdata[\'option_editor\'], "select", $editors );
  $form->add( "option_wysiwyg", "WYSIWYG Editor", $userdata[\'option_wysiwyg\'], "select", $wysiwyg );
  $form->write( );

  cbox_zu();

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '16', '16', '2', 'Partnerverwaltung', '<?php

// partner bearbeiten und erstellen
  unset( $_POST[\'id\'] );
  if (!empty($_POST[\'title\']) && !empty($_POST[\'disc\']) && !empty($_POST[\'picurl\']) && !empty($_POST[\'url\'])) {
    if (!empty($_GET["edit"])) {
	  $edit = (int) $_GET[edit];
      $db->id_update( $prefix."content_partner", $_POST, $edit );
      msgbox( \'Partner erfolgreich editiert!\', \'Partner editiert\' );
      $datei = fopen("images/partner/partner$edit.gif","w");
      fwrite($datei, file_get_contents($_POST[\'picurl\']) );
      fclose($datei);
    } else {
	  unset( $_POST[\'id\'] );
      $db->insert( $prefix."content_partner", $_POST );
      msgbox( \'Partner erfolgreich hinzugefügt!\', \'Partner hinzugefügt\' );
      $id = $db->id();
      $datei = fopen("images/partner/partner$id.gif","w");
      fwrite($datei, file_get_contents($_POST[\'picurl\']) );
      fclose($datei);
    }
}

// partner löschen
  if (isset($_GET["del"])) {
    $del = (int) $_GET["del"];
    $db->id_del( $prefix."content_partner", $del );
	unlink("images/partner/partner$del.gif","w");
  }

// daten zum bearbeiten laden
  if( $reihe = $db->id_get( $prefix."content_partner", $_GET[\'edit\'] ) ) {
    cbox_auf( "Partner bearbeiten" );
    define( "BACKBUTTON", MODUL_SELF );    
  } else cbox_auf( "Partner einfügen" );


// formular ausgeben
if (isset($_GET[edit])) echo \'<center><img src="images/partner/partner\'.$reihe[id].\'.gif" border="0" alt="Banner nicht gefunden"></center><br><br>\';
  $form = new form( MODUL_SELF."&edit=$_GET[edit]" );
  $form->add( "title", "Seiten Name", $reihe[\'title\'], "text" );
  $form->add( "disc", "Beschreibung", $reihe[\'disc\'], "text" );
  $form->add( "picurl", "Banner Url", $reihe[\'picurl\'], "text" );
  $form->add( "url", "Link", $reihe[\'url\'], "text" );
  $form->add( "status", "Status", $reihe[\'status\'], "select", array( "Deaktiviert", "Aktiv" ) );
  $form->write( "Speichern" );
  cbox_zu();

// ausgabe der partner
  cbox_auf( $mod[\'name\'] );
  $captions = array( "id" => "ID", "title" => "Name", "disc" => "Beschreibung" );
  $moduls = $db->get( $prefix."content_partner", 1, -1, "id ASC" );
  $liste = new liste( $captions );
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Modul bearbeiten" );
  $liste->write( $moduls, "100%" );
  cbox_zu();
  
?> ', 'Sunny' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '17', '17', '4', 'Menü Verwaltung', '<?php
// modul bearbeiten und erstellen
  unset( $_POST[\'id\'] );
  if ($_POST["name"] != "")
    if (!empty($_GET["edit"])) {
       $db->update( $prefix."admin_menu", $_POST, "id = $_GET[edit]" );
       msgbox( \'Menüpunk erfolgreich editiert!\', \'Menüpunk editiert\' );
    }else {
      $db->insert( $prefix."admin_menu", $_POST );
      msgbox( \'Menüpunk erfolgreich hinzugefügt!\', \'Menüpunk hinzugefügt\' );
    }

//Menu löschen
   if (isset($_GET["del"])) {
     $db->id_del( $prefix."admin_menu", $_GET[\'del\'] );
    msgbox( \'Menüpunk erfolgreich gelöscht!\', \'Menüpunk gelöscht\' );
   }

// Daten zum Bearbeiten laden
  if( $reihe = $db->get( $prefix."admin_menu", "id = \'$_GET[edit]\'", 1 ) ) {
    cbox_auf( "Menüpunkt bearbeiten" );
    define( "BACKBUTTON", MODUL_SELF );    
  } else cbox_auf( "Menüpunkt erstellen" );

// Formular ausgeben
  $form = new form( MODUL_SELF."&edit=$_GET[edit]" );
  $form->add( "name", "Name", $reihe[\'name\'], "text" );
  $form->write( "Speichern" );
  cbox_zu();

//Ausgabe
cbox_auf( "Menüpunkte" );
  $captions = array( "id" => "ID", "name" => "Menü Gruppen" );
  $groups = $db->get( $prefix."admin_menu", 1, -1, "id ASC" );
  $liste = new liste( $captions );
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Menüpunkt bearbeiten" );
  $liste->write( $groups, "100%" );

  cbox_zu();
?>', 'Sunny' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '18', '18', '4', 'Dateiverwaltung', '<?php

if( empty( $_GET[\'edit\'])) {

// Einfügen oder Aktuallisieren von Dateien
 if( !empty( $_POST[\'name\'] )) 
   if( empty( $_GET[\'update\'] ))
     $db->insert( $prefix."admin_files", array( "name" => $_POST[\'name\'], "flag_auto_admin" => (int) $_POST[\'flag_auto_admin\'], "flag_auto_index" => (int) $_POST[\'flag_auto_index\'], "autor" => $userdata[\'name\']));
     else $db->id_update( $prefix."admin_files", array( "name" => $_POST[\'name\'], "flag_auto_admin" => (int) $_POST[\'flag_auto_admin\'], "flag_auto_index" => (int) $_POST[\'flag_auto_index\'] ), $_GET[\'update\'] );


// Formular zum einfügen und bearbeiten
 if( empty( $_GET[\'settings\'] )) {
   $form = new form( MODUL_SELF );
   cbox_auf( \'Datei erstellen\' );
 } else {
   $settings = $db->id_get( $prefix."admin_files", $_GET[\'settings\'] );
   cbox_auf( \'Datei bearbeiten\' );
   $form = new form( MODUL_SELF."&update=".$settings[\'id\'] );
 }

 $form->add( \'name\', \'Dateinamename\', $settings[\'name\'], \'text\' );
 $form->add( \'flag_auto_admin\', \'Admin einbinden\', $settings[\'flag_auto_admin\'], \'checkbox\' );
 $form->add( \'flag_auto_index\', \'Index einbinden\', $settings[\'flag_auto_index\'], \'checkbox\' );
 $form->write( \'Speichern\' );

 cbox_zu();

// Liste Aktiver Dateien
 cbox_auf( "Dateiliste" );

 $captions = array( "id" => "ID", "name" => "Name", "flag_auto_admin" => "Admin", "flag_auto_index" => "index", "autor" => "Autor" );
 $files = $db->get( $prefix."admin_files" );

 $liste = new liste( $captions );
 $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );
 $liste->addop( "[O]", MODUL_SELF."&settings=", false, "Einstellungen" ); 
 $liste->write( $files, "100%" );

 cbox_zu();

} else {

// Bearbeiten von Modulinhalt
 if( $edit_file = $db->get( $prefix."admin_files", "id = \'$_GET[edit]\'", 1 )) {

    // Aktuallisieren von odulinhalt
     if( isset( $_POST[\'file_source\'] )) {
       $db->id_update( $prefix."admin_files", array( "content" => $_POST[\'file_source\'] ), $edit_file[\'id\'] );
       $edit_file[\'content\'] = stripslashes( $_POST[\'file_source\'] );
     }

   // Öffnen der Bearbeiten Box
     cbox_auf( "Datei bearbeiten: ".$edit_file[\'name\'] );
     echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$edit_file[\'id\'].\'" name="editor" method="post">\';
     print_editor( \'file_source\', $edit_file[\'content\'], $userdata[\'option_editor\'] );
     cbox_zu();

 } else msgbox( "Das Modul wurde nicht gefunden!", "Fehler beim Öffnen" );

}

?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '19', '19', '2', 'News', '<?php
// News bearbeiten und schreiben
  unset( $_POST["id"] );
  if( !empty($_POST["title"]) && !empty($_POST["text"]) )
    if( !empty($_GET["edit"]) ) {
      $db->update( $prefix."content_news", $_POST, "id = $_GET[edit]" );
      msgbox( \'News erfolgreich editiert!\', \'News editiert\' );
    } else {
      $_POST["author"] = $userdata["id"];
      $_POST["date"] = time();
      $db->insert( $prefix."content_news", $_POST );
      msgbox( \'News erfolgreich hinzugefügt!\', \'News hinzugefügt\' );

    //Bild aus URL speichern
      if ( !empty($_POST["picurl"]) ) {
         if ( $file = @file_get_contents($_POST[\'picurl\']) ) {
           $id = $db->id();
           $datei = fopen("images/news/n".$id.".png","w");
           $file = file_get_contents($_POST[\'picurl\']);
           fwrite($datei, $file);
           fclose($datei);
           msgbox( \'Das Bild wurde aus der angegebenen URL erfolgreich gespeichert!\', \'Bild hinzugefügt\' );
         } else msgbox( \'Das angegebene Bild wurde nicht gefunden!\', \'Bild nicht gefunden\' );
      } elseif ( !empty($_FILES["pic"]) ) {
    //Bild aus dem Upload speichern
        $icon = $_FILES[\'pic\'];
        $id = $db->id();
        if( $icon[\'type\'] == "image/png" ) {
          if( @copy ($icon[\'tmp_name\'], "images/news/n".$id.".png") )
             msgbox( \'Das Bild wurde erfolgreich hinzugefügt!\', \'Bild hinzugefügt\' );
        } else msgbox( \'Es wurde kein Bild, oder ein Bild im falschen Format angegeben!\', \'Kein Bild hinzugefügt\' );
      }
    }
//Kommentar ändern
  if( isset($_POST["comment_text"]) && !empty($_POST["comment_text"]) ) {
      $_POST["text"] = $_POST["comment_text"];
      $db->update( $prefix."content_news_comments", $_POST, "id = $_GET[commentedit]" );
      msgbox( \'Kommentar erfolgreich editiert!\', \'Kommentar editiert\' );
    }

// News löschen
  if( isset($_GET["del"]) ) {
    $del = (int) $_GET["del"];
    $db->id_del( $prefix."content_news", $del );
    @unlink ( "images/news/n$del.png" );
    msgbox( \'News erfolgreich gelöscht!\', \'News gelöscht\' );
  }

// Kommentar löschen
  if( isset($_GET["commentdel"]) ) {
    $del = (int) $_GET["commentdel"];
    $db->id_del( $prefix."content_comments", $del );
    msgbox( \'Kommentar erfolgreich gelöscht!\', \'Kommentar gelöscht\' );
  }

// Daten zum Bearbeiten laden
  if( $news = $db->get( $prefix."content_news", "id = \'$_GET[edit]\'", 1) ) {
    cbox_auf( "News bearbeiten" );
    define( "BACKBUTTON", MODUL_SELF );    
  } else cbox_auf( "News schreiben" );

// Assoziatives Array mit allen Kategorien erzeugen
  $script = get_short_var( "newsscript", 0 );
  $kats = $db->get_assoc( $prefix."content_panels", "script = $script", "name" );

// Formular ausgeben
  $form = new form( MODUL_SELF."&edit=$news[id]" );
  $form->upload=true;
  $form->add( "comment", "Kommentare", $news[\'comment\'], "select", array(  "0" => "Ausgeschaltet", "1" => "Eingeschaltet" ));
  $form->add( "active", "Status", $news[\'active\'], "select", array( "0" => "Inaktiv", "1" => "Aktiv" ));
  $form->add( "panel", "Kategorie", $news[\'panel\'], "select", $kats);
  $form->add( "pic", "Bild", "", "file");
  $form->add( "picurl", "oder Bild URL", "", "text" );
  $form->add( "title", "Titel", $news[\'title\'], "text" );
  $form->add( "text", "Text", $news[\'text\'], "textarea", 15 );
  $form->write( "Speichern" );
  cbox_zu();

//Kommentar bearbeiten
  if ( isset($_GET["commentedit"]) ) {
    $comment = $db->id_get( $prefix."content_news_comments", $_GET["commentedit"]);
    cbox_auf( "Kommentar bearbeiten" );
    echo \'<form action="\'.MODUL_SELF.\'&edit=\'.$news["id"].\'&commentedit=\'.$comment["id"].\'" method="post">\';
    echo \'<table border="0" cellpadding="5" cellspacing="0" align="center"><tr><td align="center">\';
    echo \'<textarea name="comment_text" rows="7" cols="40">\'.$comment["text"].\'</textarea></td></tr>\';
    echo \'<tr><td align="center"><input type="submit" value="Speichern"> <input type="button" value="Abbrechen" onclick="window.location.href=\\\'\'.BACKBUTTON.\'\\\';">\';
    echo \'</td></tr></table>\';
    echo \'</form>\';
    cbox_zu();
  }

//Kommentare anzeigen
  if( !empty($_GET["edit"]) ) {
    cbox_auf( "Kommentare" );
    $captions = array( "id" => "ID", "author" => "Autor", "ip" => "IP", "text" => "Text" );
    $moduls = $db->get( $prefix."content_news_comments", "news_id = $news[id]", -1, "id ASC" );
    $liste = new liste( $captions );
    $liste->addop( "[X]", MODUL_SELF."&edit=$news[id]&commentdel=", true, "Löschen" );
    $liste->addop( "[E]", MODUL_SELF."&edit=$news[id]&commentedit=", false, "Kommentar bearbeiten" );
    $liste->write( $moduls, "100%" );
    cbox_zu();
  }

// Ausgabe der News
  cbox_auf( \'News Artikel\' );
  $captions = array( "id" => "ID", "title" => "Titel", "aut" => "Autor", "kat" => "Panel" );
  $moduls = $db->fetch_query( "SELECT nws.id, nws.title, usr.name aut, pnl.name kat 
                               FROM ".$prefix."content_news nws
                               LEFT JOIN ".$prefix."user_data usr ON (nws.author = usr.id)
                               LEFT JOIN ".$prefix."content_panels pnl ON (nws.panel = pnl.id)
                               ORDER BY nws.id DESC" );
                               
  $liste = new liste( $captions );
  $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );
  $liste->addop( "[E]", MODUL_SELF."&edit=", false, "News bearbeiten" );
  $liste->write( $moduls, "100%" );
  cbox_zu();
?> ', 'Sunny' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '20', '20', '6', 'Package Manager', '<?php


// Liste vorhandener Packages
 cbox_auf( "Packagelist" );

 $packages = $db->get( $prefix."update_packages" );
 $captions = array( "id" => "ID", "name" => "Name", "autor" => "Autor", 
                    "version" => "Version", "source" => "Quelle" );

 $liste = new liste( $captions );
 $liste->addop( "[U]", MODUL_SELF."&update=", false, "Nach Updates Suchen" ); 
 $liste->write( $packages, "100%" );

 cbox_zu();




?>', 'Master IV' );
REPLACE INTO `{P}admin_moduls` ( `id`, `uid`, `menu`, `name`, `content`, `autor` ) VALUES ( '21', '21', '6', 'Package Developer', '<?php

  if( empty( $_GET[\'asso\'] )) {
  
  // Package löschen
    if( !empty( $_GET[\'del\'] )) {
      $db->id_del( $prefix."update_packages", $_GET[\'del\'] );
      $db->del( $prefix."update_data", "package = \'$_GET[del]\'" );
      $db->del( $prefix."update_versions", "package = \'$_GET[del]\'" );
    }
  
  // Packeges erstellen und aktuallisieren
    if( !empty( $_POST[\'name\'] ) && !empty( $_POST[\'description\'] ))
      if( empty( $_GET[\'update\'] ))
        $db->insert( $prefix."update_packages", array( \'name\' => $_POST[\'name\'], \'description\' => $_POST[\'description\'], \'autor\' => $userdata[\'name\'] ));
        else $db->id_update( $prefix."update_packages", array( \'name\' => $_POST[\'name\'], \'description\' => $_POST[\'description\'] ), $_GET[\'update\'] );


  // Formular zum erstellen und ändern von Packages  
    if( !empty( $_GET[\'edit\'] ) &&  $editpack = $db->id_get( $prefix."update_packages", $_GET[\'edit\'] )) {
      cbox_auf( \'Package bearbeiten\' );
      define( "BACKBUTTON", MODUL_SELF );   
      $form = new form( MODUL_SELF."&update=".$editpack[\'id\'] );
    } else {
      cbox_auf( \'Package erstellen\' );  
      $form = new form( MODUL_SELF );
    }

    $form->add( "name", "Packagename", $editpack[\'name\'] ); 
    $form->add( "description", "Beschreibeung", $editpack[\'description\'], "textarea", 5 ); 
    $form->write( "Speichern" );
    cbox_zu();

  // Liste vorhandener Packages
    cbox_auf( "Packagelist" );

    $packages = $db->get( $prefix."update_packages" );
    $captions = array( "id" => "ID", "name" => "Name", "autor" => "Autor", "version" => "Version" );

    $liste = new liste( $captions );
    $liste->addop( "[Z]", MODUL_SELF."&asso=", false, "Zuweisung" );  
    $liste->addop( "[X]", MODUL_SELF."&del=", true, "Löschen" );   
    $liste->addop( "[P]", MODUL_SELF."&publish=", true, "Veröffentlichen" );    
    $liste->addop( "[E]", MODUL_SELF."&edit=", false, "Bearbeiten" );  
    $liste->write( $packages, "100%" );

    cbox_zu();

  } elseif( $pack = $db->id_get( $prefix."update_packages", $_GET[\'asso\'] )) {
  
  // Datensatz löschen
    if( !empty( $_GET[\'del\'] )) $db->id_del( $prefix."update_data", $_GET[\'del\'] );
  
  // Packeges erstellen und aktuallisieren
    if( !empty( $_POST[\'table\'] )) {
      unset( $_POST[\'id\'], $_POST[\'created\'] );
      $_POST[\'package\'] = $pack[\'id\'];
      $_POST[\'version\'] = $pack[\'version\'] + 1;
    
      if( empty( $_GET[\'update\'] )) { 
        $_POST[\'created\'] = $_POST[\'version\'];
        $db->insert( $prefix."update_data", $_POST );
      } else $db->id_update( $prefix."update_data", $_POST, $_GET[\'update\'] );
    }

  // Schnelles hinzufügen
    if( !empty( $_POST[\'add_modul\'] )) $db->insert( $prefix."update_data", array( "export" => "2", "package" => $pack[\'id\'], "version" => ($pack[\'version\'] + 1), "created" => ($pack[\'version\'] + 1), "table" => "admin_moduls", "cond" => "$_POST[add_modul]" ));
    if( !empty( $_POST[\'add_script\'] )) $db->insert( $prefix."update_data", array( "export" => "2", "package" => $pack[\'id\'], "version" => ($pack[\'version\'] + 1), "created" => ($pack[\'version\'] + 1), "table" => "admin_scripts", "cond" => "$_POST[add_script]" ));
    if( !empty( $_POST[\'add_file\'] )) $db->insert( $prefix."update_data", array( "export" => "2", "package" => $pack[\'id\'], "version" => ($pack[\'version\'] + 1), "created" => ($pack[\'version\'] + 1), "table" => "admin_files", "cond" => "$_POST[add_file]" ));


  // Formular zum hinzufügen und ändern von Datensätzen
    if( !empty( $_GET[\'edit\'] ) &&  $editdata = $db->id_get( $prefix."update_data", $_GET[\'edit\'] )) {
      cbox_auf( htmlspecialchars( $pack[\'name\'] ).\': Datensatz bearbeiten\' );
      define( "BACKBUTTON", MODUL_SELF."&asso=$pack[id]" );   
      $form = new form( MODUL_SELF."&asso=$pack[id]&update=".$editdata[\'id\'] );
    } else {
      cbox_auf( htmlspecialchars( $pack[\'name\'] ).\': Daten hinzufügen\' );  
      $form = new form( MODUL_SELF."&asso=$pack[id]" );
    }
    
    //prin